#Compile
#!/usr/local/safe/bin/perl

#-- Copyright 2002 Gary L. Beene
if ($ENV{'REQUEST_METHOD'} eq "GET") {
        $qstring = $ENV{'QUERY_STRING'};
} else {    # POST
        read(STDIN, $qstring, $ENV{'CONTENT_LENGTH'});
}

@pairs = split(/&/, $qstring);                  # split the name-value pairs
foreach $pair (@pairs)                          # loop through each pair
{
    ($name, $value) = split(/=/, $pair);        # Create a Name/Value pair set
    $value =~ tr/+/ /;                          # change + signs to spaces (alternate)
    $value =~ s/%(..)/pack("c",hex($1))/ge;     # convert the URI code
    $in{$name} = $value;                        # put in hash array %in
}

#---  increment record counter (to make new name unique)
#open (IMAGE, "+< /export/home/garylbeene/public_html/mcm/design/mcmcount.txt");
open (IMAGE, "+< ../mcm/design/mcmcount.txt");
$icount = <IMAGE>;
$icount++;
seek (IMAGE,0,0);
print IMAGE  $icount;
close IMAGE;

#---- initialize variables ----
$showparts = 1;$showpackage = 1;$showsubstrate = 1;$showsealring = 1;$showwirebondledge = 1;
$showleads = 0;$showstl = 0;$dropin=0;
$showwirebonds = 0;$showballs = 0;$showpads = 0;$showlid = 0;
$xpackageleads = 0;$ypackageleads = 0; $showint = 1;
$packageden = 0; $substrateden = 0;$sealringden = 0;$lidden = 0;$ledgeden = 0;
$area = 0;$power = 0; $thickness = 0;
$Tmax=0;$Tpart=0;$Tpatt=0;$Tint=0;$Tsub=0;$Tsatt=0;$Tpkg=0;$Tpatt=0;
$xedge = 0;$yedge = 0;$xcenter = 0;$ycenter = 0;$pc = 0;$tc = 0;$lc = 0;
$animate = 0;$render = 0; $xtemp=0; $ytemp=0; $explode=0; $measure=0;
$xsubstratemax = 0;  #placement area - not include $assemblykeepout or $substratebondpads
$ysubstratemax = 0;  #placement area - not include $assemblykeepout or $substratebondpads                            #start big as default
$starttime = time;

#--- Determine if timing analysis is required
if ($in{"ic0"} eq "999 999 999"){
  use Time::HiRes qw( gettimeofday tv_interval );
  $measure=1;
  $t0 = [ gettimeofday ] ;
}

#------ set variable from input fields
$title = $in{"title"};
$requiredleads = $in{"iio"};

if ($in{"rnd"} eq "on") { $render = 1 }
if ($in{"im"} eq "on")  { $animate = 1;}
if ($in{"iw"} eq "on")  { $showwirebonds = 1 }
if ($in{"it"} eq "on")  { $showstl = 1 }
if ($in{"ilid"} eq "on"){ $showlid = 1 }
if ($in{"icon"} eq "dropin") {$dropin = 1}

if ($in{"ib"} eq "on" && $in{"iif"} eq "bga") { $showballs = 1 }
if ($in{"ib"} eq "on" && $in{"iif"} eq "leaded") { $showleads = 1 }
if ($in{"ib"} eq "on" && $in{"iif"} eq "perimeter") { $showpads = 1 }

#-- solder balls
$solderden  = $in{"amsold"};
$soldersize  = $in{"sbd"};
$solderpitch = $in{"sbp"};

#-- pads
$padpitch     = $in{"ppp"};
$padthickness = $in{"ppt"};
$padwidth     = $in{"ppw"};
$padlength    = $in{"ppl"};

#-- leads
$leadthickness = $in{"slt"};
$leadwidth     = $in{"slw"};
$leadlength    = $in{"sll"};
$leadpitch     = $in{"slp"};
if ($in{"slm"} eq "kovar") { $leadden = $in{"amkd"}}
if ($in{"slm"} eq "copper") { $leadden = $in{"amcud"}}

#-- package
$cornerkeepout       = $in{"spbk"};
$dropinkeepout       = $in{"spd"};
$lidthickness        = $in{"slidt"};
$lidkeepout          = $in{"slk"};
$leadledgewidth      = $in{"splw"};
$packagethickness    = $in{"spt"};
$sealringwidth       = $in{"spsw"};
$sealringkeepout     = $in{"spsk"};
$wirebondledgewidth  = $in{"spwbw"};
$wirebondledgeheight = $in{"spwbh"};

if ($in{"slidm"} eq "kovar") { $lidden = $in{"amkd"}}
if ($in{"slidm"} eq "aluminum") { $lidden = $in{"amad"}}
if ($in{"slidm"} eq "plastic") { $lidden = $in{"ampd"}}

if ($in{"ssm"} eq "kovar") { $sealringden = $in{"amkd"}}
if ($in{"ssm"} eq "aluminum") { $sealringden = $in{"amad"}}
if ($in{"ssm"} eq "plastic") { $sealringden = $in{"ampd"}}

if ($in{"ips"} eq "kovar") { $packageden = $in{"amkd"}}
if ($in{"ips"} eq "ceramic") { $packageden = $in{"amcd"}}
if ($in{"ips"} eq "laminate") { $packageden = $in{"amld"}}
if ($in{"ips"} eq "rdl") { $packageden = $in{"amrd"}}

$ledgeden = $packageden;

#-- substrate / interconnect
$intthickness        = $in{"sst"};
$wirebondkeepout     = $in{"ssw"};
$assemblykeepout     = $in{"ssa"};
$substratebondpads   = $in{"ssbp"};
$substratepitch      = $in{"ssp"};
$substratethickness  = $in{"sbt"};

if ($in{"iint"} eq "thick") { $intden = $in{"amtd"}}
if ($in{"iint"} eq "thin") { $intden = $in{"amthind"}}
if ($in{"iint"} eq "laminate") { $intden = $in{"amld"}}
if ($in{"iint"} eq "rdl") { $intden = $in{"amrd"}}
if ($in{"sbm"}  eq "silicon") { $substrateden = $in{"amtd"}}
if ($in{"sbm"}  eq "ceramic") { $substrateden = $in{"amthind"}}
if ($in{"sbm"}  eq "aln") { $substrateden = $in{"amld"}}

#--- set values per construction settings -----------

if ($in{"icon"} eq "integrated") {
  $substratebondpads   = 0;
  $dropinkeepout       = 0;
  $wirebondledgewidth  = 0;
  $wirebondledgeheight = 0;
  $intthickness        = 0;
  $substratethickness  = 0;
  $showwirebondledge   = 0;
  $showsubstrate       = 0;
  $showint             = 0;
  $showwirebonds       = 0;
}
if ($in{"iif"} eq "bga") {     # if "leaded", then no change
  $leadledgewidth = 0;
}
if ($in{"iif"} eq "perimeter") {   # if "leaded" then no change
  $leadledgewidth = 0;
}
if ($showsealring == 0) {
  $sealringwidth = 0;
}


#--- set calculation or dependency variables

$packagekeepout      = $assemblykeepout+$substratebondpads+$dropinkeepout+$sealringwidth+$wirebondledgewidth+$leadledgewidth+$sealringkeepout;
$substratekeepout    = $assemblykeepout+$substratebondpads;
$partcount           = $in{"imem"}+$in{"iproc"}+$in{"ia"}+$in{"ic"}+$in{"ires"}+$in{"icl"}+$in{"imc"}+$in{"ioth"};
$leadoverlap         = $leadledgewidth / 2;
$wboverlap           = $wirebondledgewidth / 2;

if ($in{"imem"}) {  if ($thickness < $in{"amt"} ) { $thickness = $in{"amt" } };}
if ($in{"iproc"})  {  if ($thickness < $in{"apt"} ) { $thickness = $in{"apt" } };}
if ($in{"icl"}) {  if ($thickness < $in{"alt"} ) { $thickness = $in{"alt" } };}
if ($in{"ia"}) {  if ($thickness < $in{"aat"} ) { $thickness = $in{"aat" } };}
if ($in{"ioth"}) {  if ($thickness < $in{"aot"} ) { $thickness = $in{"aot" }  };}
if ($in{"ires"})  {  if ($thickness < $in{"art"} ) { $thickness = $in{"art" } };}
if ($in{"ic"})  {  if ($thickness < $in{"act"} ) { $thickness = $in{"act" } };}
if ($in{"imc"})  {  if ($thickness < $in{"abt"} ) { $thickness = $in{"abt" }  };}

$thickness = $thickness + $packagethickness + $substratethickness + $intthickness + $lidkeepout + $lidthickness;

$sealringheight = $thickness - $lidthickness - $wirebondledgeheight - $packagethickness;
if ($showsealring == 0) {
  $sealringheight = 0;
}

#--- set color scheme ----------

$ic0 = "192 192 192";
$ic1  = $ic0;
$ic2  = $ic0;
$ic3  = $ic0;
$ic4  = $ic0;
$ic5  = $ic0;
$ic6  = $ic0;
$ic7  = $ic0;
$ic8  = $ic0;
$ic9  = $ic0;
$ic10 = $ic0;
$ic11 = $ic0;
$ic12 = $ic0;

if ($in{"bcs"} eq "on") { $ibackground = "255 255 255" }
else { $ibackground = "0 0 0" };

if ($in{"icol"} eq "cust") {
  $ic0 = $in{"ic0"};
  $ic1 = $in{"ic1"};
  $ic2 = $in{"ic2"};
  $ic3 = $in{"ic3"};
  $ic4 = $in{"ic4"};
  $ic5 = $in{"ic5"};
  $ic6 = $in{"ic6"};
  $ic7 = $in{"ic7"};
  $ic8 = $in{"ic8"};
  $ic9 = $in{"ic9"};
  $ic10= $in{"ic10"};
  $ic11= $in{"ic11"};
  $ic12= $in{"ic12"};
}
else {
  $ic0 = "220 220 220"; #mono
  $ic1 = "237 185 146"; #pkg
  $ic2 = "78 158 167";  #parts14
  $ic3 = "255 165 74";  #parts58
  $ic4 = "216 254 165"; #int
  $ic5 = "255 240 157"; #sub
  $ic6 = "198 224 227"; #ledge
  $ic7 = "255 255 0";   #sealring
  $ic8 = "255 255 0";   #lid
  $ic9 = "255 255 0";   #leads
  $ic10= "228 228 228"; #balls
  $ic11= "255 255 0";   #pads
  $ic12= "255 255 0";   #wires
}

if ($in{"icol"} eq "mono") {
  $colorlid = 0;
  $colorpart14 = 0;
  $colorpart58 = 0;
  $colorint = 0;
  $colorsub = 0;
  $colorpkg = 0;
  $colorseal = 0;
  $colorledge = 0;
  $colorwire = 0;
  $colorballs = 0;
  $colorleads = 0;
  $colorpads = 0;
}
else {
  $colorlid = 8;
  $colorpart14 = 2;
  $colorpart58 = 3;
  $colorint = 4;
  $colorsub = 5;
  $colorpkg = 1;
  $colorledge = 6;
  $colorseal = 7;
  $colorwire = 12;
  $colorballs = 10;
  $colorleads = 11;
  $colorpads = 9;
}

if ($measure) { $timerresult1 = tv_interval ( $t0 );}

#---- Components --------------
#                   long   short    t     keep  x  y  ptype
# $allparts[0]   = "0.500::0.500::0.020::0.050::0::0::xxx";  #sample $allparts element

#--- memory parts ---
for  ($i=0; $i<$in{"imem"}; $i=$i+1)
{ push @allparts, $in{"amw"}."::".$in{"aml"}."::".$in{"amt"}."::".$in{"amk"}."::0::0::$colorpart14" }
#--- processor parts ---
for  ($i=0; $i<$in{"iproc"}; $i=$i+1)
{ push @allparts, $in{"apw"}."::".$in{"apl"}."::".$in{"apt"}."::".$in{"apk"}."::0::0::$colorpart14" }
#--- resistors parts ---
for  ($i=0; $i<$in{"ires"}; $i=$i+1)
{ push @allparts, $in{"arw"}."::".$in{"arl"}."::".$in{"art"}."::".$in{"ark"}."::0::0::$colorpart58" }
#--- capacitors parts ---
for  ($i=0; $i<$in{"ic"}; $i=$i+1)
{ push @allparts, $in{"acw"}."::".$in{"acl"}."::".$in{"act"}."::".$in{"ack"}."::0::0::$colorpart58" }
#--- control logic parts ---
for  ($i=0; $i<$in{"icl"}; $i=$i+1)
{ push @allparts, $in{"alw"}."::".$in{"all"}."::".$in{"alt"}."::".$in{"alk"}."::0::0::$colorpart14" }
#--- ASICs parts ---
for  ($i=0; $i<$in{"ia"}; $i=$i+1)
{ push @allparts, $in{"aaw"}."::".$in{"aal"}."::".$in{"aat"}."::".$in{"aak"}."::0::0::$colorpart14" }
#--- Memory Cubes parts ---
for  ($i=0; $i<$in{"imc"}; $i=$i+1)
{ push @allparts, $in{"abw"}."::".$in{"abl"}."::".$in{"abt"}."::".$in{"abk"}."::0::0::$colorpart58" }
#--- other parts ---
for  ($i=0; $i<$in{"ioth"}; $i=$i+1)
{ push @allparts, $in{"aow"}."::".$in{"aol"}."::".$in{"aot"}."::".$in{"aok"}."::0::0::$colorpart58" }

@allparts = reverse sort @allparts;

if ($measure) { $timerresult2 = tv_interval ( $t0 );}

#---- area, weight, power ------
$area = $area + ($in{"amw"}+$in{"amk"})*($in{"aml"}+$in{"amk"})*$in{"imem"};
$area = $area + ($in{"apw"}+$in{"apk"})*($in{"apl"}+$in{"apk"})*$in{"iproc"};
$area = $area + ($in{"arw"}+$in{"ark"})*($in{"arl"}+$in{"ark"})*$in{"ires"};
$area = $area + ($in{"acw"}+$in{"ack"})*($in{"acl"}+$in{"ack"})*$in{"ic"};
$area = $area + ($in{"alw"}+$in{"alk"})*($in{"all"}+$in{"alk"})*$in{"icl"};
$area = $area + ($in{"aaw"}+$in{"aak"})*($in{"aal"}+$in{"aak"})*$in{"ia"};
$area = $area + ($in{"abw"}+$in{"abk"})*($in{"abl"}+$in{"abk"})*$in{"imc"};
$area = $area + ($in{"aow"}+$in{"aok"})*($in{"aol"}+$in{"aok"})*$in{"ioth"};
$area = $area * $in{"ssr"};   #was part area, now add extra area for aspect ratio control

$weightparts = $weightparts + $in{"amw"}*$in{"aml"}*$in{"amt"}*$in{"amd"}*$in{"imem"};
$weightparts = $weightparts + $in{"apw"}*$in{"apl"}*$in{"apt"}*$in{"apd"}*$in{"iproc"};
$weightparts = $weightparts + $in{"arw"}*$in{"arl"}*$in{"art"}*$in{"ard"}*$in{"ires"};
$weightparts = $weightparts + $in{"acw"}*$in{"acl"}*$in{"act"}*$in{"acd"}*$in{"ic"};
$weightparts = $weightparts + $in{"alw"}*$in{"all"}*$in{"alt"}*$in{"ald"}*$in{"icl"};
$weightparts = $weightparts + $in{"aaw"}*$in{"aal"}*$in{"aat"}*$in{"aad"}*$in{"ia"};
$weightparts = $weightparts + $in{"abw"}*$in{"abl"}*$in{"abt"}*$in{"abd"}*$in{"imc"};
$weightparts = $weightparts + $in{"aow"}*$in{"aol"}*$in{"aot"}*$in{"aod"}*$in{"ioth"};

$power = $power + $in{"amp"}*$in{"imem"} + $in{"app"}*$in{"iproc"} + $in{"arp"}*$in{"ires"};
$power = $power + $in{"acp"}*$in{"ic"} + $in{"alp"}*$in{"icl"} + $in{"aap"}*$in{"ia"};
$power = $power + $in{"abp"}*$in{"imc"} + $in{"aop"}*$in{"ioth"};

#--- Thermal analysis   DeltaT = (P*t) / (theta*A) ---- areapwr = P/A

if ($power) {
$Tmemareapwr  = $in{"amp"}/$in{"amw"}/$in{"aml"};
$Tprocareapwr = $in{"app"}/$in{"apw"}/$in{"apl"};
$Tresareapwr  = $in{"arp"}/$in{"arw"}/$in{"arl"};
$Tcapareapwr  = $in{"acp"}/$in{"acw"}/$in{"acl"};
$Tlogicareapwr= $in{"alp"}/$in{"alw"}/$in{"all"};
$Tasicareapwr = $in{"aap"}/$in{"aaw"}/$in{"aal"};
$Tcubeareapwr = $in{"abp"}/$in{"abw"}/$in{"abl"};
$Tothareapwr  = $in{"aop"}/$in{"aow"}/$in{"aol"};

if ($in{"tmp"} eq "epoxyn") { $h1 = $in{"ame1h"}; $n1 = "Epoxy"}
if ($in{"tmp"} eq "epoxyc") { $h1 = $in{"ame2h"}; $n1 = "Epoxy (conductive)"}
if ($in{"tmp"} eq "solder") { $h1 = $in{"amsolh"}; $n1 = "Solder"}

if ($in{"iint"} eq "thick") { $h2 = $in{"amth"}; $n2 = "Thick film"}
if ($in{"iint"} eq "thin") { $h2 = $in{"amthinh"}; $n2 = "Thin film"}
if ($in{"iint"} eq "laminate") { $h2 = $in{"amlh"}; $n2 = "Laminate"}
if ($in{"iint"} eq "rdl") { $h2 = $in{"amrh"}; $n2 = "RDL"}

if ($in{"sbm"} eq "silicon") { $h3 = $in{"amsih"}; $n3 = "Silicon"}
if ($in{"sbm"} eq "ceramic") { $h3 = $in{"amch"}; $n3 = "Ceramic"}
if ($in{"sbm"} eq "aln") { $h3 = $in{"amalnh"}; $n3 = "Aluminum Nitride"}

if ($in{"tms"} eq "epoxyn") { $h4 = $in{"ame1h"}; $n4 = "Epoxy"}
if ($in{"tms"} eq "epoxyc") { $h4 = $in{"ame2h"}; $n4 = "Epoxy (conductive)"}
if ($in{"tms"} eq "solder") { $h4 = $in{"amsolh"}; $n4 = "Solder"}

if ($in{"ips"} eq "ceramic") { $h5 = $in{"amch"}; $n5 = "Ceramic"}
if ($in{"ips"} eq "kovar") { $h5 = $in{"amkh"}; $n5 = "Kovar"}
if ($in{"ips"} eq "laminate") { $h5 = $in{"amlh"}; $n5 = "Laminate"}
if ($in{"ips"} eq "rdl") { $h5 = $in{"amrh"}; $n5 = "RDL"}

if ($in{"tmpkg"} eq "epoxyn") { $h6 = $in{"ame1h"}; $n6 = "Epoxy"}
if ($in{"tmpkg"} eq "epoxyc") { $h6 = $in{"ame2h"}; $n6 = "Epoxy (conductive)"}
if ($in{"tmpkg"} eq "solder") { $h6 = $in{"amsolh"}; $n6 = "Solder"}

$Tmempart  = $Tmemareapwr * $in{"amt"} / $in{"amh"};
$Tmempatt  = $Tmemareapwr * $in{"tmpt"} / $h1;
$Tmemint  = $Tmemareapwr * $in{"sst"} / $h2;
$Tmemsub  = $Tmemareapwr * $in{"sbt"} / $h3;
$Tmemsatt  = $Tmemareapwr * $in{"tmst"} / $h4;
$Tmempkg  = $Tmemareapwr * $in{"spt"} / $h5;
$Tmemkatt  = $Tmemareapwr * $in{"tmpkgt"} / $h6;

$Tprocpart = $Tprocareapwr * $in{"apt"} / $in{"aph"};
$Tprocpatt = $Tprocareapwr * $in{"tmpt"} / $h1;
$Tprocint = $Tprocareapwr * $in{"sst"} / $h2;
$Tprocsub = $Tprocareapwr * $in{"sbt"} / $h3;
$Tprocsatt = $Tprocareapwr * $in{"tmst"} / $h4;
$Tprocpkg = $Tprocareapwr * $in{"spt"} / $h5;
$Tprockatt = $Tprocareapwr * $in{"tmpkgt"} / $h6;

$Trespart  = $Tresareapwr * $in{"art"} / $in{"arh"};
$Trespatt  = $Tresareapwr * $in{"tmpt"} / $h1;
$Tresint  = $Tresareapwr * $in{"sst"} / $h2;
$Tressub  = $Tresareapwr * $in{"sbt"} / $h3;
$Tressatt  = $Tresareapwr * $in{"tmst"} / $h4;
$Trespkg  = $Tresareapwr * $in{"spt"} / $h5;
$Treskatt  = $Tresareapwr * $in{"tmpkgt"} / $h6;

$Tcappart  = $Tcapareapwr * $in{"act"} / $in{"ach"};
$Tcappatt  = $Tcapareapwr * $in{"tmpt"} / $h1;
$Tcapint  = $Tcapareapwr * $in{"sst"} / $h2;
$Tcapsub  = $Tcapareapwr * $in{"sbt"} / $h3;
$Tcapsatt  = $Tcapareapwr * $in{"tmst"} / $h4;
$Tcappkg  = $Tcapareapwr * $in{"spt"} / $h5;
$Tcapkatt  = $Tcapareapwr * $in{"tmpkgt"} / $h6;

$Tlogicpart= $Tlogicareapwr * $in{"alt"} / $in{"alh"};
$Tlogicpatt= $Tlogicareapwr * $in{"tmpt"} / $h1;
$Tlogicint= $Tlogicareapwr * $in{"sst"} / $h2;
$Tlogicsub= $Tlogicareapwr * $in{"sbt"} / $h3;
$Tlogicsatt= $Tlogicareapwr * $in{"tmst"} / $h4;
$Tlogicpkg= $Tlogicareapwr * $in{"spt"} / $h5;
$Tlogickatt= $Tlogicareapwr * $in{"tmpkgt"} / $h6;

$Tasicpart = $Tasicareapwr * $in{"aat"} / $in{"aah"};
$Tasicpatt = $Tasicareapwr * $in{"tmpt"} / $h1;
$Tasicint = $Tasicareapwr * $in{"sst"} / $h2;
$Tasicsub = $Tasicareapwr * $in{"sbt"} / $h3;
$Tasicsatt = $Tasicareapwr * $in{"tmst"} / $h4;
$Tasicpkg = $Tasicareapwr * $in{"spt"} / $h5;
$Tasickatt = $Tasicareapwr * $in{"tmpkgt"} / $h6;

$Tcubepart = $Tcubeareapwr * $in{"abt"} / $in{"abh"};
$Tcubepatt = $Tcubeareapwr * $in{"tmpt"} / $h1;
$Tcubeint = $Tcubeareapwr * $in{"sst"} / $h2;
$Tcubesub = $Tcubeareapwr * $in{"sbt"} / $h3;
$Tcubesatt = $Tcubeareapwr * $in{"tmst"} / $h4;
$Tcubepkg = $Tcubeareapwr * $in{"spt"} / $h5;
$Tcubekatt = $Tcubeareapwr * $in{"tmpkgt"} / $h6;

$Tothpart  = $Tothareapwr * $in{"aot"} / $in{"aoh"};
$Tothpatt  = $Tothareapwr * $in{"tmpt"} / $h1;
$Tothint  = $Tothareapwr * $in{"sst"} / $h2;
$Tothsub  = $Tothareapwr * $in{"sbt"} / $h3;
$Tothsatt  = $Tothareapwr * $in{"tmst"} / $h4;
$Tothpkg  = $Tothareapwr * $in{"spt"} / $h5;
$Tothkatt  = $Tothareapwr * $in{"tmpkgt"} / $h6;

#--- reset Thermal values based on construction rules

if ($in{"icon"} eq "integrated") {
  $Tmemsub  = 0; $Tmemsatt = 0;
  $Tprocsub  = 0; $Tprocsatt = 0;
  $Tressub  = 0; $Tressatt = 0;
  $Tcapsub  = 0; $Tcapsatt = 0;
  $Tlogicsub  = 0; $Tlogicsatt = 0;
  $Tasicsub  = 0; $Tasicsatt = 0;
  $Tcubesub  = 0; $Tcubesatt = 0;
  $Tothsub  = 0; $Tothsatt = 0;
}

$Tmem  = $Tmempart+$Tmempatt+$Tmemint+$Tmemsub+$Tmemsatt+$Tmempkg+$Tmemkatt;
$Tproc  = $Tprocpart+$Tprocpatt+$Tprocint+$Tprocsub+$Tprocsatt+$Tprocpkg+$Tprockatt;
$Tasic  = $Tasicpart+$Tasicpatt+$Tasicint+$Tasicsub+$Tasicsatt+$Tasicpkg+$Tasickatt;
$Tcap  = $Tcappart+$Tcappatt+$Tcapint+$Tcapsub+$Tcapsatt+$Tcappkg+$Tcapkatt;
$Tres  = $Trespart+$Trespatt+$Tresint+$Tressub+$Tressatt+$Trespkg+$Treskatt;
$Tlogic  = $Tlogicpart+$Tlogicpatt+$Tlogicint+$Tlogicsub+$Tlogicsatt+$Tlogicpkg+$Tlogickatt;
$Tcube  = $Tcubepart+$Tcubepatt+$Tcubeint+$Tcubesub+$Tcubesatt+$Tcubepkg+$Tcubekatt;
$Toth  = $Tothpart+$Tothpatt+$Tothint+$Tothsub+$Tothsatt+$Tothpkg+$Tothkatt;

if ($in{"imem"} == 0) { $Tmem = 0 }
if ($in{"iproc"} == 0){ $Tproc = 0 }
if ($in{"ia"} == 0)   { $Tasic = 0 }
if ($in{"ic"} == 0)   { $Tcap = 0 }
if ($in{"ires"} == 0) { $Tres = 0 }
if ($in{"icl"} == 0)  { $Tlogic = 0 }
if ($in{"imc"} == 0)  { $Tcube = 0 }
if ($in{"ioth"} == 0) { $Toth = 0 }

if ($Tmax < $Tmem)  {
  $Tname = $in{"nam1"};
  $Tmax = $Tmem;
  $Tpart = $Tmempart;
  $Tpatt = $Tmempatt;
  $Tint  = $Tmemint;
  $Tsub  = $Tmemsub;
  $Tsatt = $Tmemsatt;
  $Tpkg  = $Tmempkg;
  $Tkatt = $Tmemkatt;
}
if ($Tmax < $Tproc) {
  $Tname = $in{"nam3"};
  $Tmax = $Tproc;
  $Tpart = $Tprocpart;
  $Tpatt = $Tprocpatt;
  $Tint  = $Tprocint;
  $Tsub  = $Tprocsub;
  $Tsatt = $Tprocsatt;
  $Tpkg  = $Tprocpkg;
  $Tkatt = $Tprockatt;
}
if ($Tmax < $Tres)  {
  $Tname = $in{"nam2"};
  $Tmax = $Tres;
  $Tpart = $Trespart;
  $Tpatt = $Trespatt;
  $Tint  = $Tresint;
  $Tsub  = $Tressub;
  $Tsatt = $Tressatt;
  $Tpkg  = $Trespkg;
  $Tkatt = $Treskatt;
}
if ($Tmax < $Tcap)  {
  $Tname = $in{"nam7"};
  $Tmax = $Tcap;
  $Tpart = $Tcappart;
  $Tpatt = $Tcappatt;
  $Tint  = $Tcapint;
  $Tsub  = $Tcapsub;
  $Tsatt = $Tcapsatt;
  $Tpkg  = $Tcappkg;
  $Tkatt = $Tcapkatt;
}
if ($Tmax < $Tlogic){
  $Tname = $in{"nam4"};
  $Tmax = $Tlogic;
  $Tpart = $Tlogicpart;
  $Tpatt = $Tlogicpatt;
  $Tint  = $Tlogicint;
  $Tsub  = $Tlogicsub;
  $Tsatt = $Tlogicsatt;
  $Tpkg  = $Tlogicpkg;
  $Tkatt = $Tlogickatt;
}
if ($Tmax < $Tasic) {
  $Tname = $in{"nam5"};
  $Tmax = $Tasic;
  $Tpart = $Tasicpart;
  $Tpatt = $Tasicpatt;
  $Tint  = $Tasicint;
  $Tsub  = $Tasicsub;
  $Tsatt = $Tasicsatt;
  $Tpkg  = $Tasicpkg;
  $Tkatt = $Tasickatt;
}
if ($Tmax < $Tcube) {
  $Tname = $in{"nam6"};
  $Tmax = $Tcube;
  $Tpart = $Tcubepart;
  $Tpatt = $Tcubepatt;
  $Tint  = $Tcubeint;
  $Tsub  = $Tcubesub;
  $Tsatt = $Tcubesatt;
  $Tpkg  = $Tcubepkg;
  $Tkatt = $Tcubekatt;
}
if ($Tmax < $Toth)  {
  $Tname = $in{"nam8"};
  $Tmax = $Toth;
  $Tpart = $Tothpart;
  $Tpatt = $Tothpatt;
  $Tint  = $Tothint;
  $Tsub  = $Tothsub;
  $Tsatt = $Tothsatt;
  $Tpkg  = $Tothpkg;
  $Tkatt = $Tothkatt;
}
}

if ($measure) { $timerresult3 = tv_interval ( $t0 );}


if ($in{"plc"} eq "Std") {
   #---- set center for each part (placement) ----
   if ($area) {
     $xsubstratemax = sqrt $area;  #set starting point for x
     $ysubstratemax = sqrt $area;  #set starting point for y
   }
   else {
     $xsubstratemax = 0.1;  #default value for when no parts are used
     $ysubstratemax = 0.1;  #default value for when no parts are used
   }
   $x=0; $y=0;
   for $part (@allparts) {
     ($l, $w, $t, $k, $x, $y, $ptype) = split(/::/,$part);
     $lk = $l + 2*$k;
     $wk = $w + 2*$k;
     if ($xedge == 0) {
         $ycenter = $lk/2;
         $yedge = $lk;
     }
     if ( ($xedge + $wk) <= $xsubstratemax) {
         $xcenter = $xedge + $wk/2;    # must come before next line
         $xedge = $xedge + $wk;
     }
     else {
         $xedge = $wk;
         $xcenter = $wk/2;
         $ycenter = $yedge + $lk/2;   # must come before next line
         $yedge = $yedge + $lk;
     }
     $part = join("::",$l, $w, $t, $k, $ycenter, $xcenter, $ptype);
     if ($xtemp < $xedge) { $xtemp = $xedge };
     if ($ytemp < $yedge) { $ytemp = $yedge };
   }
}

if ($in{"plc"} eq "Rnd") {
   #---- randomly sort the part array before placement ---
   while (@allparts)
      { push (@tempparts, splice(@allparts, rand @allparts, 1)); }
   @allparts = @tempparts;

   #---- set center for each part (placement) ----

   if ($area) {
     $xsubstratemax = sqrt $area;  #set starting point for x
     $ysubstratemax = sqrt $area;  #set starting point for y
   }
      else {
     $xsubstratemax = 0.1;  #default value for when no parts are used
     $ysubstratemax = 0.1;  #default value for when no parts are used
   }
   $x=0; $y=0; $xedge=0; $yedge=0; $yborder=0; $lmax=0;
   for $part (@allparts) {
     ($l, $w, $t, $k, $x, $y, $ptype) = split(/::/,$part);
     $lk = $l + 2*$k;
     $wk = $w + 2*$k;
     if ( ($xedge + $wk) <= $xsubstratemax) {
         $xcenter = $xedge + $wk/2;    # must come before next line
         $xedge = $xedge + $wk;
         if ($lk > $lmax) { $lmax = $lk }
     }
     else {
         $xcenter = $wk/2;
         $xedge = $wk;
         $yborder = $yborder + $lmax;
         $lmax = $lk;
     }
     $ycenter = $yborder + $lk/2;   # must come before next line
     $yedge = $yborder + $lk;
     $part = join("::",$l, $w, $t, $k, $ycenter, $xcenter, $ptype);
     if ($xtemp < $xedge) { $xtemp = $xedge };
     if ($ytemp < $yedge) { $ytemp = $yedge };
   }
}

if ($in{"plc"} eq "Opt") {
   #---- set center for each part (placement) ----
   if ($area) {
     $xsubstratemax = sqrt $area;  #set starting point for x
     $ysubstratemax = sqrt $area;  #set starting point for y
   }
   else {
     $xsubstratemax = 0.1;  #default value for when no parts are used
     $ysubstratemax = 0.1;  #default value for when no parts are used
   }
   $x=0; $y=0;

   #---- re-arrange @allparts in Opt positions ----
   @newparts = @allparts;
   $last = $#allparts;
   for ($i = 0; $i <= $last; $i++) {
     ($l, $w, $t, $k, $x, $y, $ptype) = split(/::/,$newparts[0]);
     $wk = $w + 2*$k;
     if ( ($xedge + $wk) <= $xsubstratemax) {
         $xedge = $xedge + $wk;
     }
     else {
         #--- reverse order of remainder of @newparts
         @newparts = reverse (@newparts);
         #--- use data from 1st element ---
         ($l, $w, $t, $k, $x, $y, $ptype) = split(/::/,$newparts[0]);
         $wk = $w + 2*$k;
         $xedge = $wk;
     }
     #--- add to @arrangedparts
     push (@arrangedparts, $newparts[0]);
     #--- delete first element from @newparts
     shift (@newparts);
   }
   @allparts = @arrangedparts;

   #---- use re-arranged @allparts to set centers ----
   $x=0; $y=0; $xedge=0; $yedge=0; $yborder=0; $lmax=0;
   for $part (@allparts) {
     ($l, $w, $t, $k, $x, $y, $ptype) = split(/::/,$part);
     $lk = $l + 2*$k;
     $wk = $w + 2*$k;
     if ( ($xedge + $wk) <= $xsubstratemax) {
         $xcenter = $xedge + $wk/2;    # must come before next line
         $xedge = $xedge + $wk;
         if ($lk > $lmax) { $lmax = $lk }
     }
     else {
         $xcenter = $wk/2;
         $xedge = $wk;
         $yborder = $yborder + $lmax;
         $lmax = $lk;
     }
     $ycenter = $yborder + $lk/2;   # must come before next line
     $yedge = $yborder + $lk;
     $part = join("::",$l, $w, $t, $k, $ycenter, $xcenter, $ptype);
     if ($xtemp < $xedge) { $xtemp = $xedge };
     if ($ytemp < $yedge) { $ytemp = $yedge };
   }
}

if($xtemp) {
  $xsubstratemax = $xtemp;  #set x size to results of placement
  $ysubstratemax = $ytemp;  #set y size to results of placement
}
$px = $xsubstratemax + 2*$packagekeepout;
$py = $ysubstratemax + 2*$packagekeepout;
$sx = $xsubstratemax + 2*$substratekeepout;
$sy = $ysubstratemax + 2*$substratekeepout;

# removed $oldxsubstratemax ... here

if ($measure) { $timerresult4 = tv_interval ( $t0 );}

#---- save points in an array @points (placement) --------

if ($showparts) {

$z = $packagethickness + $substratethickness + $intthickness;  #just a holding variable, used later

for $part (@allparts) {
  ($l, $w, $t, $k, $yc, $xc, $ptype) = split(/::/,$part);

  if ($colorpart14 == 0) {$ptype = 0};

  $p0x = $xc - $w/2;
  $p0y = $yc - $l/2;
  $p0z = $z;
  $p1x = $xc + $w/2;
  $p1y = $yc - $l/2;
  $p1z = $z;
  $p2x = $xc + $w/2;
  $p2y = $yc + $l/2;
  $p2z = $z;
  $p3x = $xc - $w/2;
  $p3y = $yc + $l/2;
  $p3z = $z;
  $p4x = $xc - $w/2;
  $p4y = $yc - $l/2;
  $p4z = $z  + $t;
  $p5x = $xc + $w/2;
  $p5y = $yc - $l/2;
  $p5z = $z  + $t;
  $p6x = $xc + $w/2;
  $p6y = $yc + $l/2;
  $p6z = $z  + $t;
  $p7x = $xc - $w/2;
  $p7y = $yc + $l/2;
  $p7z = $z  + $t;

  push @points, "p ".($p0x+$packagekeepout)." ".($p0y+$packagekeepout)." ".$p0z;
  push @points, "p ".($p1x+$packagekeepout)." ".($p1y+$packagekeepout)." ".$p1z;
  push @points, "p ".($p2x+$packagekeepout)." ".($p2y+$packagekeepout)." ".$p2z;
  push @points, "p ".($p3x+$packagekeepout)." ".($p3y+$packagekeepout)." ".$p3z;
  push @points, "p ".($p4x+$packagekeepout)." ".($p4y+$packagekeepout)." ".$p4z;
  push @points, "p ".($p5x+$packagekeepout)." ".($p5y+$packagekeepout)." ".$p5z;
  push @points, "p ".($p6x+$packagekeepout)." ".($p6y+$packagekeepout)." ".$p6z;
  push @points, "p ".($p7x+$packagekeepout)." ".($p7y+$packagekeepout)." ".$p7z;

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$ptype;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$ptype;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$ptype;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$ptype;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$ptype;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$ptype;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$ptype;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$ptype;   #473
#  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$ptype;   #032
#  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$ptype;   #210
  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$ptype;   #456
  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$ptype;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 10;  # $tc = trianglecount
#  $tc = $tc + 12;  # $tc = trianglecount
  if ($showstl) {
    push @xpoints, sprintf("%.3f",$p0x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p1x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p2x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p3x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p4x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p5x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p6x+$packagekeepout);
    push @xpoints, sprintf("%.3f",$p7x+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p0y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p1y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p2y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p3y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p4y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p5y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p6y+$packagekeepout);
    push @ypoints, sprintf("%.3f",$p7y+$packagekeepout);
    push @zpoints, sprintf("%.3f",$p0z);
    push @zpoints, sprintf("%.3f",$p1z);
    push @zpoints, sprintf("%.3f",$p2z);
    push @zpoints, sprintf("%.3f",$p3z);
    push @zpoints, sprintf("%.3f",$p4z);
    push @zpoints, sprintf("%.3f",$p5z);
    push @zpoints, sprintf("%.3f",$p6z);
    push @zpoints, sprintf("%.3f",$p7z);
  }
}
}

if ($measure) { $timerresult5 = tv_interval ( $t0 );}

#------- I/O driven package size - reset xsubstratemax/ysubstratemax as needed  -----

#keep same aspect ratio in defining leads

if ($in{"rsize"} eq "on") {
  $leadmsg = " Package size is constrained<br>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp to fit components";
}
else {
  if ($in{"iif"} eq "perimeter") {
    $iopx = ($requiredleads) / 2 * $xsubstratemax / ($xsubstratemax+$ysubstratemax) * $padpitch + 2 * $cornerkeepout + $padwidth;
    $iopy = ($requiredleads) / 2 * $ysubstratemax / ($xsubstratemax+$ysubstratemax) * $padpitch + 2 * $cornerkeepout + $padwidth;
    $ioxsubstratemax = $iopx - 2*$packagekeepout;
    $ioysubstratemax = $iopy - 2*$packagekeepout;
    $iosx = $ioxsubstratemax + 2*$substratekeepout;
    $iosy = $ioysubstratemax + 2*$substratekeepout;
  }
  if ($in{"iif"} eq "leaded") {
    $iopx = ($requiredleads) / 2 * $xsubstratemax / ($xsubstratemax+$ysubstratemax) * $leadpitch + 2 * $cornerkeepout + $leadwidth;
    $iopy = ($requiredleads) / 2 * $ysubstratemax / ($xsubstratemax+$ysubstratemax) * $leadpitch + 2 * $cornerkeepout + $leadwidth;
    $ioxsubstratemax = $iopx - 2*$packagekeepout;
    $ioysubstratemax = $iopy - 2*$packagekeepout;
    $iosx = $ioxsubstratemax + 2*$substratekeepout;
    $iosy = $ioysubstratemax + 2*$substratekeepout;
  }
  if ($in{"iif"} eq "bga") {
    $yballs = sprintf("%.0f",sqrt ($requiredleads / $xsubstratemax * $ysubstratemax));
    $xballs = sprintf("%.0f",($requiredleads / $yballs));
    $iopx = $xballs * $solderpitch + 2 * $cornerkeepout + $soldersize ;
    $iopy = $yballs * $solderpitch + 2 * $cornerkeepout + $soldersize ;
    $ioxsubstratemax = $iopx - 2*$packagekeepout;
    $ioysubstratemax = $iopy - 2*$packagekeepout;
    $iosx = $ioxsubstratemax + 2*$substratekeepout;
    $iosy = $ioysubstratemax + 2*$substratekeepout;
  }

  if ($xsubstratemax < $ioxsubstratemax) {
    $xsubstratemax = $ioxsubstratemax;
    $ysubstratemax = $ioysubstratemax;
    $sx = $iosx;
    $sy = $iosy;
    $px = $iopx;
    $py = $iopy;
    $leadmsg = "Package size is I/O driven.";
  }
  else {
    $leadmsg = "Package size is parts driven.";
  }

}

if ($measure) { $timerresult6 = tv_interval ( $t0 );}

#---- Lead/pad/ball/wirebond counts ---------------

$xpackageleads = sprintf("%.0f",($px-2*$cornerkeepout) / $leadpitch);
$ypackageleads = sprintf("%.0f",($py-2*$cornerkeepout) / $leadpitch);

$xpackagepads = sprintf("%.0f",($px-2*$cornerkeepout) / $padpitch);
$ypackagepads = sprintf("%.0f",($py-2*$cornerkeepout) / $padpitch);

$xsubstratewires = sprintf("%.0f",($sx-2*$wirebondkeepout) / $substratepitch);
$ysubstratewires = sprintf("%.0f",($sy-2*$wirebondkeepout) / $substratepitch);

$xpackageballs = sprintf("%.0f",($px-2*$cornerkeepout) / $solderpitch);
$ypackageballs = sprintf("%.0f",($py-2*$cornerkeepout) / $solderpitch);

if ($in{"iif"} eq "perimeter") {
$trueleads = 2*$xpackagepads + 2*$ypackagepads;
$leadmsg2 = "($xpackagepads x $ypackagepads)";
}
if ($in{"iif"} eq "leaded") {
$trueleads = 2*$xpackageleads + 2*$ypackageleads;
$leadmsg2 = "($xpackageleads x $ypackageleads)";
}
if ($in{"iif"} eq "bga") {
$trueleads =   $xpackageballs * $ypackageballs;
$leadmsg2 = "($xpackageballs x $ypackageballs)";
}


#---- Section Weights ---------------

# weight of pads is considered zero!

$weightint = $sx * $sy * $intthickness * $intden ;
$weightsubstrate = $sx * $sy * $substratethickness * $substrateden ;
$weightpackage = $px * $py * $packagethickness * $packageden;
$weightlid =      $px * $py * $lidthickness * $lidden;
$weightballs = ($xpackageballs+$ypackageballs) * $solderden * 3.14 * 4 / 3 / 8 * $in{"sbd"} * $in{"sbd"} * $in{"sbd"} ;
$weightleads = 2*($xpackageleads + $ypackageleads) * $leadden * $in{"sll"} * $in{"slw"} * $in{"slt"};

$L1 = $px - 2*($sealringkeepout+$leadledgewidth);
$L2 = $py - 2*($sealringkeepout+$leadledgewidth+$sealringwidth);
$weightsealring = ($L1 + $L2) * 2 * $sealringwidth * $sealringheight * $sealringden;

$w = $wirebondledgewidth + $sealringwidth + $sealringkeepout;
$L1 = $px - 2*$leadledgewidth;
$L2 = $py - 2*($wirebondledgewidth+$sealringwidth+$sealringkeepout+$leadledgewidth);
$weightledge = ($L1 + $L2) * 2 * $w * $wirebondledgeheight * $ledgeden;

if ($in{"iif"} ne "bga") { $weightballs=0 }
if ($in{"iif"} ne "leaded") { $weightleads = 0 }
if ($in{"icon"} eq "integrated") { $weightsubstrate = 0; $weightint=0; $weightledge=0;}

$weight = $weightparts + $weightint + $weightsubstrate + $weightpackage + $weightledge;
$weight = $weight + $weightlid + $weightsealring + $weightballs + $weightleads;

if ($measure) { $timerresult7 = tv_interval ( $t0 );}

#---- Package - including lead ledge as required ---------------

if ($showpackage) {
$p0x = 0;
$p0y = 0;
$p0z = 0;
$p1x = $px;
$p1y = 0;
$p1z = 0;
$p2x = $px;
$p2y = $py;
$p2z = 0;
$p3x = 0;
$p3y = $py;
$p3z = 0;
$p4x = 0;
$p4y = 0;
$p4z = $packagethickness;
$p5x = $px;
$p5y = 0;
$p5z = $packagethickness;
$p6x = $px;
$p6y = $py;
$p6z = $packagethickness;
$p7x = 0;
$p7y = $py;
$p7z = $packagethickness;

push @points, "p ".$p0x." ".$p0y." ".$p0z;
push @points, "p ".$p1x." ".$p1y." ".$p1z;
push @points, "p ".$p2x." ".$p2y." ".$p2z;
push @points, "p ".$p3x." ".$p3y." ".$p3z;
push @points, "p ".$p4x." ".$p4y." ".$p4z;
push @points, "p ".$p5x." ".$p5y." ".$p5z;
push @points, "p ".$p6x." ".$p6y." ".$p6z;
push @points, "p ".$p7x." ".$p7y." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorpkg;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorpkg;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorpkg;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorpkg;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorpkg;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorpkg;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorpkg;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorpkg;   #473
push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorpkg;   #032
push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorpkg;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorpkg;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorpkg;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult8 = tv_interval ( $t0 );}

#---- Substrate ---------------

if ($showsubstrate) {

$move = $dropinkeepout+$sealringwidth+$wirebondledgewidth+$leadledgewidth +$sealringkeepout;

$p0x = 0;
$p0y = 0;
$p0z = $packagethickness;
$p1x = $sx;
$p1y = 0;
$p1z = $packagethickness;
$p2x = $sx;
$p2y = $sy;
$p2z = $packagethickness;
$p3x = 0;
$p3y = $sy;
$p3z = $packagethickness;
$p4x = 0;
$p4y = 0;
$p4z = $packagethickness + $substratethickness;
$p5x = $sx;
$p5y = 0;
$p5z = $packagethickness + $substratethickness;
$p6x = $sx;
$p6y = $sy;
$p6z = $packagethickness + $substratethickness;
$p7x = 0;
$p7y = $sy;
$p7z = $packagethickness + $substratethickness;

push @points, "p ".($p0x+$move)." ".($p0y+$move)." ".$p0z;
push @points, "p ".($p1x+$move)." ".($p1y+$move)." ".$p1z;
push @points, "p ".($p2x+$move)." ".($p2y+$move)." ".$p2z;
push @points, "p ".($p3x+$move)." ".($p3y+$move)." ".$p3z;
push @points, "p ".($p4x+$move)." ".($p4y+$move)." ".$p4z;
push @points, "p ".($p5x+$move)." ".($p5y+$move)." ".$p5z;
push @points, "p ".($p6x+$move)." ".($p6y+$move)." ".$p6z;
push @points, "p ".($p7x+$move)." ".($p7y+$move)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorsub;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorsub;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorsub;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorsub;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorsub;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorsub;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorsub;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorsub;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorsub;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorsub;   #210
#push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorsub;   #456
#push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorsub;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 8;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult9 = tv_interval ( $t0 );}

#---- Interconnect ---------------

if ($showint) {

$move = $dropinkeepout+$sealringwidth+$wirebondledgewidth+$leadledgewidth +$sealringkeepout;

$p0x = 0;
$p0y = 0;
$p0z = $packagethickness+$substratethickness;
$p1x = $sx;
$p1y = 0;
$p1z = $packagethickness+$substratethickness;
$p2x = $sx;
$p2y = $sy;
$p2z = $packagethickness+$substratethickness;
$p3x = 0;
$p3y = $sy;
$p3z = $packagethickness+$substratethickness;
$p4x = 0;
$p4y = 0;
$p4z = $packagethickness + $substratethickness +$intthickness;
$p5x = $sx;
$p5y = 0;
$p5z = $packagethickness + $substratethickness +$intthickness;
$p6x = $sx;
$p6y = $sy;
$p6z = $packagethickness + $substratethickness +$intthickness;
$p7x = 0;
$p7y = $sy;
$p7z = $packagethickness + $substratethickness +$intthickness;

push @points, "p ".($p0x+$move)." ".($p0y+$move)." ".$p0z;
push @points, "p ".($p1x+$move)." ".($p1y+$move)." ".$p1z;
push @points, "p ".($p2x+$move)." ".($p2y+$move)." ".$p2z;
push @points, "p ".($p3x+$move)." ".($p3y+$move)." ".$p3z;
push @points, "p ".($p4x+$move)." ".($p4y+$move)." ".$p4z;
push @points, "p ".($p5x+$move)." ".($p5y+$move)." ".$p5z;
push @points, "p ".($p6x+$move)." ".($p6y+$move)." ".$p6z;
push @points, "p ".($p7x+$move)." ".($p7y+$move)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorint;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorint;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorint;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorint;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorint;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorint;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorint;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorint;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorint;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorint;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorint;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorint;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult10 = tv_interval ( $t0 );}

#---- Seal Ring ---------------

# right vertical side (seal ring)

if ($showsealring){

$d1 = $leadledgewidth + $sealringkeepout;
$d2 = $d1 + $sealringwidth;

$p0x = $px - $d2;
$p0y = $d2;
$p0z = $packagethickness + $wirebondledgeheight;
$p1x = $px - $d1;
$p1y = $d2;
$p1z = $packagethickness + $wirebondledgeheight ;
$p2x = $px - $d1;
$p2y = $py - $d2;
$p2z = $packagethickness + $wirebondledgeheight ;
$p3x = $px - $d2;
$p3y = $py - $d2;
$p3z = $packagethickness + $wirebondledgeheight ;
$p4x = $px - $d2;
$p4y = $d2;
$p4z = $packagethickness + $sealringheight + $wirebondledgeheight ;
$p5x = $px - $d1;
$p5y = $d2;
$p5z = $packagethickness + $sealringheight + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $py - $d2;
$p6z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p7x = $px - $d2;
$p7y = $py - $d2;
$p7z = $packagethickness + $sealringheight  + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorseal;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorseal;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorseal;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorseal;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorseal;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorseal;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorseal;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorseal;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorseal;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorseal;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorseal;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorseal;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount


# left vertical side (seal ring)

$p0x = $d1;
$p0y = $d2;
$p0z = $packagethickness + $wirebondledgeheight ;
$p1x = $d2;
$p1y = $d2;
$p1z = $packagethickness + $wirebondledgeheight ;
$p2x = $d2;
$p2y = $py - $d2;
$p2z = $packagethickness  + $wirebondledgeheight;
$p3x = $d1;
$p3y = $py - $d2;
$p3z = $packagethickness + $wirebondledgeheight ;
$p4x = $d1;
$p4y = $d2;
$p4z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p5x = $d2;
$p5y = $d2;
$p5z = $packagethickness + $sealringheight + $wirebondledgeheight;
$p6x = $d2;
$p6y = $py - $d2;
$p6z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p7x = $d1;
$p7y = $py - $d2;
$p7z = $packagethickness + $sealringheight  + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorseal;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorseal;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorseal;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorseal;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorseal;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorseal;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorseal;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorseal;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorseal;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorseal;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorseal;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorseal;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount

# top horizontal side (seal ring)

$p0x = $d1;
$p0y = $py - $d2;
$p0z = $packagethickness  + $wirebondledgeheight;
$p1x = $px - $d1;
$p1y = $py - $d2;
$p1z = $packagethickness  + $wirebondledgeheight;
$p2x = $px - $d1;
$p2y = $py - $d1;
$p2z = $packagethickness  + $wirebondledgeheight;
$p3x = $d1;
$p3y = $py - $d1;
$p3z = $packagethickness  + $wirebondledgeheight;
$p4x = $d1;
$p4y = $py - $d2;
$p4z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p5x = $px - $d1;
$p5y = $py - $d2;
$p5z = $packagethickness + $sealringheight + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $py - $d1;
$p6z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p7x = $d1;
$p7y = $py - $d1;
$p7z = $packagethickness + $sealringheight  + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorseal;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorseal;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorseal;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorseal;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorseal;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorseal;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorseal;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorseal;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorseal;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorseal;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorseal;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorseal;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount

# bottom horizontal side (seal ring)

$p0x = $d1;
$p0y = $d1;
$p0z = $packagethickness  + $wirebondledgeheight;
$p1x = $px - $d1;
$p1y = $d1;
$p1z = $packagethickness   + $wirebondledgeheight;
$p2x = $px - $d1;
$p2y = $d2;
$p2z = $packagethickness   + $wirebondledgeheight;
$p3x = $d1;
$p3y = $d2;
$p3z = $packagethickness  + $wirebondledgeheight;
$p4x = $d1;
$p4y = $d1;
$p4z = $packagethickness + $sealringheight   + $wirebondledgeheight;
$p5x = $px - $d1;
$p5y = $d1;
$p5z = $packagethickness + $sealringheight  + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $d2;
$p6z = $packagethickness + $sealringheight   + $wirebondledgeheight;
$p7x = $d1;
$p7y = $d2;
$p7z = $packagethickness + $sealringheight   + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorseal;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorseal;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorseal;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorseal;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorseal;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorseal;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorseal;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorseal;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorseal;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorseal;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorseal;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorseal;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult11 = tv_interval ( $t0 );}

#---- Lid ---------------

if ($showlid) {

$d1 = $leadledgewidth + $sealringkeepout;
if ($in{"slx"} eq "on") { $explode = 2 * $thickness }

$p0x = $d1;
$p0y = $d1;
$p0z = $thickness - $lidthickness + $explode;
$p1x = $px - $d1;
$p1y = $d1;
$p1z = $thickness - $lidthickness + $explode;
$p2x = $px - $d1;
$p2y = $py - $d1;
$p2z = $thickness - $lidthickness + $explode;
$p3x = $d1;
$p3y = $py - $d1;
$p3z = $thickness - $lidthickness + $explode;
$p4x = $d1;
$p4y = $d1;
$p4z = $thickness + $explode;
$p5x = $px - $d1;
$p5y = $d1;
$p5z = $thickness + $explode;
$p6x = $px - $d1;
$p6y = $py - $d1;
$p6z = $thickness + $explode;
$p7x = $d1;
$p7y = $py - $d1;
$p7z = $thickness + $explode;

push @points, "p ".$p0x." ".$p0y." ".$p0z;
push @points, "p ".$p1x." ".$p1y." ".$p1z;
push @points, "p ".$p2x." ".$p2y." ".$p2z;
push @points, "p ".$p3x." ".$p3y." ".$p3z;
push @points, "p ".$p4x." ".$p4y." ".$p4z;
push @points, "p ".$p5x." ".$p5y." ".$p5z;
push @points, "p ".$p6x." ".$p6y." ".$p6z;
push @points, "p ".$p7x." ".$p7y." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorlid;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorlid;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorlid;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorlid;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorlid;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorlid;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorlid;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorlid;   #473
push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorlid;   #032
push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorlid;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorlid;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorlid;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult12 = tv_interval ( $t0 );}

#---- Wirebondledge -------------

# right vertical side (wirebond ledge)

if ($showwirebondledge){

$d1 = $leadledgewidth;
$d2 = $leadledgewidth + $sealringkeepout + $sealringwidth + $wirebondledgewidth;

$p0x = $px - $d2;
$p0y = $d2;
$p0z = $packagethickness;
$p1x = $px - $d1;
$p1y = $d2;
$p1z = $packagethickness ;
$p2x = $px - $d1;
$p2y = $py - $d2;
$p2z = $packagethickness ;
$p3x = $px - $d2;
$p3y = $py - $d2;
$p3z = $packagethickness ;
$p4x = $px - $d2;
$p4y = $d2;
$p4z = $packagethickness + $wirebondledgeheight ;
$p5x = $px - $d1;
$p5y = $d2;
$p5z = $packagethickness + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $py - $d2;
$p6z = $packagethickness + $wirebondledgeheight;
$p7x = $px - $d2;
$p7y = $py - $d2;
$p7z = $packagethickness + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorledge;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorledge;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorledge;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorledge;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorledge;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorledge;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorledge;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorledge;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorledge;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorledge;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorledge;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorledge;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount

# left vertical side (wirebond ledge)

$p0x = $d1;
$p0y = $d2;
$p0z = $packagethickness;
$p1x = $d2;
$p1y = $d2;
$p1z = $packagethickness ;
$p2x = $d2;
$p2y = $py - $d2;
$p2z = $packagethickness;
$p3x = $d1;
$p3y = $py - $d2;
$p3z = $packagethickness;
$p4x = $d1;
$p4y = $d2;
$p4z = $packagethickness + $wirebondledgeheight;
$p5x = $d2;
$p5y = $d2;
$p5z = $packagethickness + $wirebondledgeheight;
$p6x = $d2;
$p6y = $py - $d2;
$p6z = $packagethickness + $wirebondledgeheight;
$p7x = $d1;
$p7y = $py - $d2;
$p7z = $packagethickness + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorledge;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorledge;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorledge;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorledge;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorledge;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorledge;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorledge;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorledge;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorledge;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorledge;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorledge;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorledge;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount

# top horizontal side (wirebond ledge)

$p0x = $d1;
$p0y = $py - $d2;
$p0z = $packagethickness;
$p1x = $px - $d1;
$p1y = $py - $d2;
$p1z = $packagethickness;
$p2x = $px - $d1;
$p2y = $py - $d1;
$p2z = $packagethickness;
$p3x = $d1;
$p3y = $py - $d1;
$p3z = $packagethickness;
$p4x = $d1;
$p4y = $py - $d2;
$p4z = $packagethickness + $wirebondledgeheight;
$p5x = $px - $d1;
$p5y = $py - $d2;
$p5z = $packagethickness + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $py - $d1;
$p6z = $packagethickness + $wirebondledgeheight;
$p7x = $d1;
$p7y = $py - $d1;
$p7z = $packagethickness + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorledge;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorledge;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorledge;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorledge;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorledge;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorledge;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorledge;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorledge;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorledge;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorledge;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorledge;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorledge;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount

# bottom horizontal side (wirebond ledge)

$p0x = $d1;
$p0y = $d1;
$p0z = $packagethickness;
$p1x = $px - $d1;
$p1y = $d1;
$p1z = $packagethickness;
$p2x = $px - $d1;
$p2y = $d2;
$p2z = $packagethickness;
$p3x = $d1;
$p3y = $d2;
$p3z = $packagethickness;
$p4x = $d1;
$p4y = $d1;
$p4z = $packagethickness + $wirebondledgeheight;
$p5x = $px - $d1;
$p5y = $d1;
$p5z = $packagethickness + $wirebondledgeheight;
$p6x = $px - $d1;
$p6y = $d2;
$p6z = $packagethickness + $wirebondledgeheight;
$p7x = $d1;
$p7y = $d2;
$p7z = $packagethickness + $wirebondledgeheight;

push @points, "p ".($p0x)." ".($p0y)." ".$p0z;
push @points, "p ".($p1x)." ".($p1y)." ".$p1z;
push @points, "p ".($p2x)." ".($p2y)." ".$p2z;
push @points, "p ".($p3x)." ".($p3y)." ".$p3z;
push @points, "p ".($p4x)." ".($p4y)." ".$p4z;
push @points, "p ".($p5x)." ".($p5y)." ".$p5z;
push @points, "p ".($p6x)." ".($p6y)." ".$p6z;
push @points, "p ".($p7x)." ".($p7y)." ".$p7z;

push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorledge;   #015
push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorledge;   #540
push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorledge;   #126
push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorledge;   #651
push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorledge;   #237
push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorledge;   #762
push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorledge;   #304
push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorledge;   #473
#push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorledge;   #032
#push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorledge;   #210
push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorledge;   #456
push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorledge;   #674

$pc = $pc + 8 ;  # $pc = pointcount
$tc = $tc + 10;  # $tc = trianglecount
#$tc = $tc + 12;  # $tc = trianglecount
}

if ($measure) { $timerresult13 = tv_interval ( $t0 );}

#---- Solder balls (BGA only) -------------

if ($showballs){
$d1 = $cornerkeepout;
$d2 = $soldersize / 4 ;  #offset to make top of ball smaller

#--- entire array --- solderballs

$gapy = $py - 2 * $cornerkeepout;
$gapx = $px - 2 * $cornerkeepout;
$edge2edgey = ($ypackageballs-1)*$solderpitch + $soldersize;
$edge2edgex = ($xpackageballs-1)*$solderpitch + $soldersize;
$offsety = ($gapy - $edge2edgey)/2;
$offsetx = ($gapx - $edge2edgex)/2;
$ymove = $cornerkeepout + $offsetx - $solderpitch;
$k = $soldersize/4;

for  ($j=0; $j<$ypackageballs; $j=$j+1) {
  $xmove = $cornerkeepout + $offsetx - $solderpitch;
  $ymove = $ymove + $solderpitch;
  for  ($i=0; $i<$xpackageballs; $i=$i+1) {
    $xmove = $xmove + $solderpitch;

    push @points, "p ".($xmove+$k)." ".($ymove+$k)." ".-$soldersize;
    push @points, "p ".($xmove+$soldersize-$k)." ".($ymove+$k)." ".-$soldersize;
    push @points, "p ".($xmove+$soldersize-$k)." ".($ymove+$soldersize-$k)." ".-$soldersize;
    push @points, "p ".($xmove+$k)." ".($ymove+$soldersize-$k)." ".-$soldersize;
    push @points, "p ".($xmove)." ".($ymove)." 0";
    push @points, "p ".($xmove+$soldersize)." ".($ymove)." 0";
    push @points, "p ".($xmove+$soldersize)." ".($ymove+$soldersize)." 0";
    push @points, "p ".($xmove)." ".($ymove+$soldersize)." 0";

    push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorballs;   #015
    push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorballs;   #540
    push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorballs;   #126
    push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorballs;   #651
    push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorballs;   #237
    push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorballs;   #762
    push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorballs;   #304
    push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorballs;   #473
    push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorballs;   #032
    push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorballs;   #210
#    push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorballs;   #456
#    push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorballs;   #674

    $pc = $pc + 8 ;  # $pc = pointcount
#   $tc = $tc + 12;  # $tc = trianglecount
    $tc = $tc + 10;  # $tc = trianglecount
  }
}
}

if ($measure) { $timerresult14 = tv_interval ( $t0 );}

#---- Wirebonds (drop-in only -------------

if ($showwirebonds){

$gapy = $sy - 2 * $wirebondkeepout;
$gapx = $sx - 2 * $wirebondkeepout;
$edge2edgey = ($ysubstratewires -1)*$substratepitch;
$edge2edgex = ($xsubstratewires -1)*$substratepitch;
$offsety = ($gapy - $edge2edgey)/2;
$offsetx = ($gapx - $edge2edgex)/2;

$z = $packagethickness + $substratethickness + $intthickness;

$d1 = $leadledgewidth + $sealringkeepout + $sealringwidth + $wirebondledgewidth;
$d2 = $d1 + $dropinkeepout;

#--- right vertical side --- wirebonds, dropin
$move = $wirebondkeepout + $offsety - $substratepitch;
for  ($i=0; $i<$ysubstratewires; $i=$i+1) {
  $move = $move + $substratepitch;
  push @points, "p ".($px-$d2-$wboverlap)." ".($d2+$move)." ".$z;
  push @points, "p ".($px-$d1+$wboverlap)." ".($d2+$move)." ".$z;
  push @lines, "l ".($pc+0)." ".($pc+1)." ".$colorwire;
  $pc = $pc + 2;  # $pc = pointcount
  $lc = $lc + 1;  # $lc = linecount
}
#--- left vertical side --- wirebonds, dropin
$move = $wirebondkeepout + $offsety - $substratepitch;
for  ($i=0; $i<$ysubstratewires; $i=$i+1) {
  $move = $move + $substratepitch;
  push @points, "p ".($d2+$wboverlap)." ".($py-$d2-$move)." ".$z;
  push @points, "p ".($d1-$wboverlap)." ".($py-$d2-$move)." ".$z;
  push @lines, "l ".($pc+0)." ".($pc+1)." ".$colorwire;
  $pc = $pc + 2;  # $pc = pointcount
  $lc = $lc + 1;  # $lc = linecount
}
#--- top horizontal side --- wirebonds, dropin
$move = $wirebondkeepout + $offsetx - $substratepitch;
for  ($i=0; $i<$xsubstratewires; $i=$i+1) {
  $move = $move + $substratepitch;
  push @points, "p ".($px-$d2-$move)." ".($py-$d2-$wboverlap)." ".$z;
  push @points, "p ".($px-$d2-$move)." ".($py-$d1+$wboverlap)." ".$z;
  push @lines, "l ".($pc+0)." ".($pc+1)." ".$colorwire;
  $pc = $pc + 2;  # $pc = pointcount
  $lc = $lc + 1;  # $lc = linecount
}

#--- bottom horizontal side --- wirebonds, dropin
$move = $wirebondkeepout + $offsetx - $substratepitch;
for  ($i=0; $i<$xsubstratewires; $i=$i+1) {
  $move = $move + $substratepitch;
  push @points, "p ".($d2+$move)." ".($d2+$wboverlap)." ".$z;
  push @points, "p ".($d2+$move)." ".($d1-$wboverlap)." ".$z;
  push @lines, "l ".($pc+0)." ".($pc+1)." ".$colorwire;
  $pc = $pc + 2;  # $pc = pointcount
  $lc = $lc + 1;  # $lc = linecount
}
}

if ($measure) { $timerresult15 = tv_interval ( $t0 );}

#---- Leads -------------
if ($showleads){
$gapy = $py - 2 * $cornerkeepout;
$gapx = $px - 2 * $cornerkeepout;
$edge2edgey = ($ypackageleads -1)*$leadpitch + $leadwidth;
$edge2edgex = ($xpackageleads -1)*$leadpitch + $leadwidth;
$offsety = ($gapy - $edge2edgey)/2;
$offsetx = ($gapx - $edge2edgex)/2;
$top = $packagethickness+$leadthickness;

#--- right vertical side --- leads
$move = $cornerkeepout + $offsety - $leadpitch;
for  ($i=0; $i<$ypackageleads; $i=$i+1) {
  $move = $move + $leadpitch;

  push @points, "p ".($px-$leadoverlap)." ".($move+$leadwidth)." ".($packagethickness);
  push @points, "p ".($px-$leadoverlap)." ".($move)." ".($packagethickness);
  push @points, "p ".($px+$leadlength)." ".($move)." ".($packagethickness);
  push @points, "p ".($px+$leadlength)." ".($move+$leadwidth)." ".($packagethickness);
  push @points, "p ".($px-$leadoverlap)." ".($move+$leadwidth)." ".$top;
  push @points, "p ".($px-$leadoverlap)." ".($move)." ".$top;
  push @points, "p ".($px+$leadlength)." ".($move)." ".$top;
  push @points, "p ".($px+$leadlength)." ".($move+$leadwidth)." ".$top;

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorleads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorleads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorleads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorleads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorleads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorleads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorleads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorleads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorleads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorleads;   #210
  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorleads;   #456
  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorleads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 12;  # $tc = trianglecount

}
#--- left vertical side --- leads
$move = $cornerkeepout + $offsety - $leadpitch;
for  ($i=0; $i<$ypackageleads; $i=$i+1) {
  $move = $move + $leadpitch;

  push @points, "p ".(-$leadlength)." ".($move+$leadwidth)." ".($packagethickness);
  push @points, "p ".(-$leadlength)." ".($move)." ".($packagethickness);
  push @points, "p ".($leadoverlap)." ".($move)." ".($packagethickness);
  push @points, "p ".($leadoverlap)." ".($move+$leadwidth)." ".($packagethickness);
  push @points, "p ".(-$leadlength)." ".($move+$leadwidth)." ".$top;
  push @points, "p ".(-$leadlength)." ".($move)." ".$top;
  push @points, "p ".($leadoverlap)." ".($move)." ".$top;
  push @points, "p ".($leadoverlap)." ".($move+$leadwidth)." ".$top;

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorleads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorleads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorleads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorleads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorleads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorleads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorleads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorleads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorleads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorleads;   #210
  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorleads;   #456
  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorleads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 12;  # $tc = trianglecount

}
#--- top horizontal side --- leads
$move = $cornerkeepout + $offsetx - $leadpitch;
for  ($i=0; $i<$xpackageleads; $i=$i+1) {
  $move = $move + $leadpitch;

  push @points, "p ".($move)." ".($py-$leadoverlap)." ".($packagethickness);
  push @points, "p ".($move+$leadwidth)." ".($py-$leadoverlap)." ".($packagethickness);
  push @points, "p ".($move+$leadwidth)." ".($py+$leadlength)." ".($packagethickness);
  push @points, "p ".($move)." ".($py+$leadlength)." ".($packagethickness);
  push @points, "p ".($move)." ".($py-$leadoverlap)." ".$top;
  push @points, "p ".($move+$leadwidth)." ".($py-$leadoverlap)." ".$top;
  push @points, "p ".($move+$leadwidth)." ".($py+$leadlength)." ".$top;
  push @points, "p ".($move)." ".($py+$leadlength)." ".$top;

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorleads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorleads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorleads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorleads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorleads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorleads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorleads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorleads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorleads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorleads;   #210
  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorleads;   #456
  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorleads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 12;  # $tc = trianglecount

}

#--- bottom horizontal side --- leads
$move = $cornerkeepout + $offsetx - $leadpitch;
for  ($i=0; $i<$xpackageleads; $i=$i+1) {
  $move = $move + $leadpitch;

  push @points, "p ".($move)." ".(-$leadlength)." ".($packagethickness);
  push @points, "p ".($move+$leadwidth)." ".(-$leadlength)." ".($packagethickness);
  push @points, "p ".($move+$leadwidth)." ".($leadoverlap)." ".($packagethickness);
  push @points, "p ".($move)." ".($leadoverlap)." ".($packagethickness);
  push @points, "p ".($move)." ".(-$leadlength)." ".$top;
  push @points, "p ".($move+$leadwidth)." ".(-$leadlength)." ".$top;
  push @points, "p ".($move+$leadwidth)." ".($leadoverlap)." ".$top;
  push @points, "p ".($move)." ".($leadoverlap)." ".$top;

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorleads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorleads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorleads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorleads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorleads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorleads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorleads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorleads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorleads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorleads;   #210
  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorleads;   #456
  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorleads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 12;  # $tc = trianglecount
}

}

if ($measure) { $timerresult16 = tv_interval ( $t0 );}

#---- Perimeter Pads -------------

if ($showpads){

$gapy = $py - 2 * $cornerkeepout;
$gapx = $px - 2 * $cornerkeepout;
$edge2edgey = ($ypackagepads -1)*$padpitch + $padwidth;
$edge2edgex = ($xpackagepads -1)*$padpitch + $padwidth;
$offsety = ($gapy - $edge2edgey)/2;
$offsetx = ($gapx - $edge2edgex)/2;

#--- right vertical side --- perimeter pads
$move = $cornerkeepout + $offsety - $padpitch;
for  ($i=0; $i<$ypackagepads; $i=$i+1) {
  $move = $move + $padpitch;

  push @points, "p ".($px-$padlength)." ".($move+$padwidth)." ".(-$padthickness);
  push @points, "p ".($px-$padlength)." ".($move)." ".(-$padthickness);
  push @points, "p ".($px)." ".($move)." ".(-$padthickness);
  push @points, "p ".($px)." ".($move+$padwidth)." ".(-$padthickness);
  push @points, "p ".($px-$padlength)." ".($move+$padwidth)." ".(0);
  push @points, "p ".($px-$padlength)." ".($move)." ".(0);
  push @points, "p ".($px)." ".($move)." ".(0);
  push @points, "p ".($px)." ".($move+$padwidth)." ".(0);

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorpads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorpads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorpads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorpads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorpads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorpads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorpads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorpads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorpads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorpads;   #210
#  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorpads;   #456
#  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorpads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 10;  # $tc = trianglecount
#  $tc = $tc + 12;  # $tc = trianglecount

}
#--- left vertical side ---  perimeter pads
$move = $cornerkeepout + $offsety - $padpitch;
for  ($i=0; $i<$ypackagepads; $i=$i+1) {
  $move = $move + $padpitch;

  push @points, "p ".(0)." ".($move+$padwidth)." ".(-$padthickness);
  push @points, "p ".(0)." ".($move)." ".(-$padthickness);
  push @points, "p ".($padlength)." ".($move)." ".(-$padthickness);
  push @points, "p ".($padlength)." ".($move+$padwidth)." ".(-$padthickness);
  push @points, "p ".(0)." ".($move+$padwidth)." ".(0);
  push @points, "p ".(0)." ".($move)." ".(0);
  push @points, "p ".($padlength)." ".($move)." ".(0);
  push @points, "p ".($padlength)." ".($move+$padwidth)." ".(0);

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorpads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorpads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorpads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorpads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorpads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorpads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorpads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorpads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorpads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorpads;   #210
#  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorpads;   #456
#  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorpads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 10;  # $tc = trianglecount
#  $tc = $tc + 12;  # $tc = trianglecount

}
#--- top horizontal side --- perimeter pads
$move = $cornerkeepout + $offsetx - $padpitch;
for  ($i=0; $i<$xpackagepads; $i=$i+1) {
  $move = $move + $padpitch;

  push @points, "p ".($move)." ".($py-$padlength)." ".(-$padthickness);
  push @points, "p ".($move+$padwidth)." ".($py-$padlength)." ".(-$padthickness);
  push @points, "p ".($move+$padwidth)." ".($py)." ".(-$padthickness);
  push @points, "p ".($move)." ".($py)." ".(-$padthickness);
  push @points, "p ".($move)." ".($py-$padlength)." ".(0);
  push @points, "p ".($move+$padwidth)." ".($py-$padlength)." ".(0);
  push @points, "p ".($move+$padwidth)." ".($py)." ".(0);
  push @points, "p ".($move)." ".($py)." ".(0);

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorpads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorpads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorpads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorpads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorpads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorpads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorpads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorpads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorpads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorpads;   #210
#  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorpads;   #456
#  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorpads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 10;  # $tc = trianglecount
#  $tc = $tc + 12;  # $tc = trianglecount

}

#--- bottom horizontal side --- perimeter pads
$move = $cornerkeepout + $offsetx - $padpitch;
for  ($i=0; $i<$xpackagepads; $i=$i+1) {
  $move = $move + $padpitch;

  push @points, "p ".($move)." ".(0)." ".(-$padthickness);
  push @points, "p ".($move+$padwidth)." ".(0)." ".(-$padthickness);
  push @points, "p ".($move+$padwidth)." ".($padlength)." ".(-$padthickness);
  push @points, "p ".($move)." ".($padlength)." ".(-$padthickness);
  push @points, "p ".($move)." ".(0)." ".(0);
  push @points, "p ".($move+$padwidth)." ".(0)." ".(0);
  push @points, "p ".($move+$padwidth)." ".($padlength)." ".(0);
  push @points, "p ".($move)." ".($padlength)." ".(0);

  push @triangles, "t ".($pc+0)." ".($pc+1)." ".($pc+5)." ".$colorpads;   #015
  push @triangles, "t ".($pc+5)." ".($pc+4)." ".($pc+0)." ".$colorpads;   #540
  push @triangles, "t ".($pc+1)." ".($pc+2)." ".($pc+6)." ".$colorpads;   #126
  push @triangles, "t ".($pc+6)." ".($pc+5)." ".($pc+1)." ".$colorpads;   #651
  push @triangles, "t ".($pc+2)." ".($pc+3)." ".($pc+7)." ".$colorpads;   #237
  push @triangles, "t ".($pc+7)." ".($pc+6)." ".($pc+2)." ".$colorpads;   #762
  push @triangles, "t ".($pc+3)." ".($pc+0)." ".($pc+4)." ".$colorpads;   #304
  push @triangles, "t ".($pc+4)." ".($pc+7)." ".($pc+3)." ".$colorpads;   #473
  push @triangles, "t ".($pc+0)." ".($pc+3)." ".($pc+2)." ".$colorpads;   #032
  push @triangles, "t ".($pc+2)." ".($pc+1)." ".($pc+0)." ".$colorpads;   #210
#  push @triangles, "t ".($pc+4)." ".($pc+5)." ".($pc+6)." ".$colorpads;   #456
#  push @triangles, "t ".($pc+6)." ".($pc+7)." ".($pc+4)." ".$colorpads;   #674

  $pc = $pc + 8 ;  # $pc = pointcount
  $tc = $tc + 10;  # $tc = trianglecount
#  $tc = $tc + 12;  # $tc = trianglecount
}

}

if ($measure) { $timerresult17 = tv_interval ( $t0 );}

#--- Print results to the file "imageXX.txt" ----------------

#@image = ("MCM 3D Image", "1 $pc 0 $tc", "c 192 192 192", @points, @triangles);
@image = (@points, @lines, @triangles);

open (OUT,"> ../mcm/design/image".$icount.".txt");
print OUT "$title\n";
print OUT "13 $pc $lc $tc\n";
print OUT "c ".$ic0."\n";
print OUT "c ".$ic1."\n";
print OUT "c ".$ic2."\n";
print OUT "c ".$ic3."\n";
print OUT "c ".$ic4."\n";
print OUT "c ".$ic5."\n";
print OUT "c ".$ic6."\n";
print OUT "c ".$ic7."\n";
print OUT "c ".$ic8."\n";
print OUT "c ".$ic9."\n";
print OUT "c ".$ic10."\n";
print OUT "c ".$ic11."\n";
print OUT "c ".$ic12."\n";
for $x (@image) {
   print OUT $x."\n";
}
close OUT;

if ($measure) { $timerresult18 = tv_interval ( $t0 );}

#------- Formatting ---------------

$px = sprintf("%.3f",$px);
$py = sprintf("%.3f",$py);
$thickness = sprintf("%.3f",$thickness);
$power = sprintf("%.2f",$power);
$trueleads = sprintf("%.0f",$trueleads);

$weight = sprintf("%.2f",$weight);
$weightparts = sprintf("%.2f",$weightparts);
$weightpackage = sprintf("%.2f",$weightpackage);
$weightsubstrate = sprintf("%.2f",$weightsubstrate);
$weightlid = sprintf("%.2f",$weightlid);
$weightsealring = sprintf("%.2f",$weightsealring);
$weightleads = sprintf("%.2f",$weightleads);
$weightballs = sprintf("%.2f",$weightballs);
$weightledge = sprintf("%.2f",$weightledge);
$weightint = sprintf("%.2f",$weightint);

$Tmax = sprintf("%.2f",$Tmax);
$Tpart = sprintf("%.2f",$Tpart);
$Tpatt = sprintf("%.2f",$Tpatt);
$Tint = sprintf("%.2f",$Tint);
$Tsub = sprintf("%.2f",$Tsub);
$Tsatt = sprintf("%.2f",$Tsatt);
$Tpkg = sprintf("%.2f",$Tpkg);
$Tkatt = sprintf("%.2f",$Tkatt);

#------- Write the imageXX.htm file ----------------------

$screen = $in{"res"};
$elapsedtime = time - $starttime +1;

open (OUT,"> ../mcm/design/image".$icount.".htm");

print OUT <<stop_html;

<html>
<head>
<title>3D Image</title>
</head>
<body>
<center>
<img width=640 height=24 border=0 src="../../images/garybeenes.gif">
<img width=640 height=60 border=0 src="../../images/mcmdesign1.gif">
</center>
<p><table>
<tr>
<td nowrap valign=top>

stop_html

$j=1;
if ($in{"mult"}) {
  $j=4;
  $screen = $screen/2;
  if ($screen < 310) { $screen = 310 }
}

for  ($i=0; $i<$j; $i=$i+1) {
  print OUT <<multiple_applet;
  <applet code=tov.class archive="tov.jar" width=$screen height=$screen>;
  <param name=regcode value=82481266383754>;
  <param name=tovdata value="image$icount.txt">
  <param name=spin value="$animate">
  <param name=display value="$render">
  <param name=anglestep value="3">
  <param name=scale value="0.7">
  <param name=mainbg value="0 192 192">
  <param name=mainfg value="0 0 0">
  <param name=butbg value="60 192 255">
  <param name=butfg value="0 0 0">
  <param name=bgcolor value="$ibackground">
  <param name=delay value=50>
  </applet>
multiple_applet
  if ($i==1) { print OUT "<br>" }
}

print OUT <<stop_html9;

<td valign=top>
<table cellspacing=0 cellpadding=0>
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
    &nbsp<b>Size (in.)</b>
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Length<td align=right>$py
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Width<td align=right>$px
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Thickness<td align=right>$thickness
        <tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp I/O Count<td nowrap align=right>$trueleads
        <tr><td><td nowrap align=right>$leadmsg2
        <tr><td>&nbsp
        <tr><td nowrap colspan=4>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp $leadmsg

<tr><td>&nbsp
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
&nbsp<b>Weight (gms)</b><td nowrap align=right>$weight

<tr><td>&nbsp
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
&nbsp<b>Power (W)</b><td nowrap align=right>$power

<tr><td>&nbsp
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
&nbsp<b>Temp Rise (C)</b>&nbsp<td align=right>$Tmax

stop_html9

if ($showstl) {
print OUT '<tr><td>&nbsp';
print OUT '<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">';
print OUT '&nbsp<a href="image'.$icount.'.stl"><b>Binary STL File</b></a>';
}

print OUT <<stop_html8;

<tr><td>&nbsp
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
&nbsp<b>Components</b><td align=right>$partcount

stop_html8

if ( $in{"imem"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam1'}<td align=right>$in{'imem'}" }

if ( $in{"ires"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam2'}<td align=right>$in{'ires'}" }

if ( $in{"iproc"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam3'}<td align=right>$in{'iproc'}" }

if ( $in{"icl"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam4'}<td align=right>$in{'icl'}" }

if ( $in{"ia"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam5'}<td align=right>$in{'ia'}" }

if ( $in{"imc"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam6'}<td align=right>$in{'imc'}" }

if ( $in{"ic"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam7'}<td align=right>$in{'ic'}" }

if ( $in{"ioth"} > 0 ) { print OUT "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
$in{'nam8'}<td align=right>$in{'ioth'}" }

print OUT <<stop_html2;

</table>

</table>

<table>
<tr><td><h3>Notes:</h3>
<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif"> <b>Thermal Analysis</b><br>
    <ul><table>
        <tr><td valign=top nowrap colspan=2><b>Maximum Temperature Rise (C)</b>&nbsp&nbsp&nbsp<td><b>$Tmax</b>
            <td>&nbsp&nbsp
            <td valign=top rowspan=8>This is a worst case thermal analysis. It assumes that all
                heat flow is to the bottom of the MCM without heat spreading. It does not
                take into account the uneven distribution of power dissipation that may result
                in digital ICs at the driver circuits lcoated at the edge of the die. In some
                ICs, as much as 30% of the device power dissipation may be located in a narrow
                band around the perimeter of the die. Even though an MCM's low parasitics help
                reduce this effect, a more detailed thermal analysis may be appropriate.<p>
                The thermal analysis correctly takes into account the die and substrate attachment
                materials, but those layers are not included in the graphics generation.
        <tr><td>Part<td nowrap>$Tname<td align=right>$Tpart
        <tr><td nowrap>Part attach<td nowrap>$n1<td align=right>$Tpatt
        <tr><td>Interconnect<td nowrap>$n2<td align=right>$Tint

stop_html2

if ($in{"icon"} ne "integrated") {
   print OUT "<tr><td>Substrate<td nowrap>$n3<td align=right>$Tsub";
   print OUT "<tr><td nowrap>Substrate attach<td nowrap>$n4<td align=right>$Tsatt";
}


print OUT <<stop_html3;

        <tr><td>Package<td nowrap>$n5<td align=right>$Tpkg
        <tr><td nowrap>Package attach<td nowrap>$n6<td align=right>$Tpatt
    </table></ul>

<tr><td nowrap><img width=14 height=14 src="/images/ballblue.gif">
    <b>Weight Analysis</b><br>
    <ul><table>
        <tr><td nowrap><b>Total Weight (gms)&nbsp&nbsp</b><td nowrap valign=top><b>$weight</b>
          <td>&nbsp&nbsp
          <td valign=top rowspan=10>The package weight includes all sections of the MCM structure, including I/O (leads and
              solder balls) except for the perimeter pads which are assumed to be integral to the
              package.  The Online MCM Design page provides a "thickness" for the pads only to
              enhance the visual image.

stop_html3

if ($weightparts > 0)     { print OUT "<tr><td>Parts<td align=right>$weightparts"}
if ($weightlid > 0)       { print OUT "<tr><td>Lid<td align=right>$weightlid"}
if ($weightpackage > 0)   { print OUT "<tr><td>Package<td align=right>$weightpackage"}
if ($weightint > 0)       { print OUT "<tr><td>Interconnect<td align=right>$weightint"}
if ($weightsubstrate > 0) { print OUT "<tr><td>Substrate<td align=right>$weightsubstrate"}
if ($weightsealring > 0)  { print OUT "<tr><td nowrap>Seal Ring<td align=right>$weightsealring"}
if ($weightledge > 0 )    { print OUT "<tr><td>Ledge<td align=right>$weightledge"}
if ($weightleads > 0 )    { print OUT "<tr><td>Leads<td align=right>$weightleads"}
if ($weightballs > 0 )    { print OUT "<tr><td nowrap>Solder balls<td align=right>$weightballs"}

print OUT <<stop_html4;

    </table></ul>
<tr><td><img width=14 height=14 src="/images/ballblue.gif"> <b>Size:</b><br>
   <ul>The overall body size of an MCM is defined by the larger of space needed to place
       the components, or the space needed to accomodate the total I/O coming off the MCM.
       A message is provided below the size table above to indicate which of the factors
       was used to determine the size of the package.  In either case, the body size given does not
       include the length of the leads, which will affect the footprint of the MCM on the
       next level of assembly. Typically, packages are purchased with relatively long leads
       which are cut to the preferred size for next-level assembly, then formed into a specific
       shape (typically a simple bend in the lead) to support solder attachment.
    <p>
       If the package body size as driven by I/O is larger than the body size as driven by
       the parts, you have several options to help reduce the size:
     <ul>
     <li>Use the larger body size despite the inefficient use of space
     <li>User a smaller I/O pitch, but check with your manufacturing organization
         to determine the smallest pitch which they can support during assembly.
     <li>Change from a perimeter or leaded construction to a BGA package style.
         Again, check with your manufacturing organization to make sure your
         proposed package style is compatible with their assembly process.
         Solder joints on BGA package sizes in excess of 1" are susceptible to
         thermal cycling problems, so be sure to analyze your design's compatibility
         with the intended environment.
     </ul>
     <p>
     In an MCM, the die and substrate are attached with adhesive materials.  The graphics
     and calculations on this page do not utilize the attachment materials, except
     in the case of the thermal analysis, where the attacment materials are taken into account.
     <p>
     When a BGA graphics is selected, the thickness of the solder balls is used to
     calculate the overall thickness of the MCM.  In practice, however, the solder balls
     may collapse significantly, lowering the overall thickness of the MCM.
   </ul>

<tr><td><img width=14 height=14 src="/images/ballblue.gif"> <b>Graphics:</b><br>
    <ul>
    This image is made of $pc points, $lc lines, and $tc triangles.<br>
    The program took less than $elapsedtime seconds to run.<br>
    This is image number $icount generated from the Online MCM Design Center script, Version 7.0

stop_html4

if ($measure) { $timerresult19 = tv_interval ( $t0 );}

#---  STL subroutines ----

sub planexy {
  $xx1=$ptx[$_[0]];  $xx2=$ptx[$_[2]];  $yy1=$pty[$_[0]];  $yy2=$pty[$_[2]];
  for ($i=0; $i<@xpoints; $i++) {
    if    ($xpoints[$i] > $xx2) { last }
    elsif ($xpoints[$i] == $xx1) { $tempx2 = $xpoints[$i] }
    elsif ($xpoints[$i] > $xx1 && $xpoints[$i] <= $xx2) {
      $tempx1 = $tempx2; $tempx2 = $xpoints[$i];
      for ($j=0; $j<@ypoints; $j++) {
        if    ($ypoints[$j] > $yy2) { last }
        elsif ($ypoints[$j] == $yy1) { $tempy2 = $ypoints[$j] }
        elsif ($ypoints[$j] > $yy1 && $ypoints[$j] <= $yy2) {
          $tempy1 = $tempy2; $tempy2 = $ypoints[$j];
          $showtriangle=1;
          if ($testtriangle){
            for $part (@allparts) {  #does triangle fall under a part?
             ($l, $w, $t, $k, $yc, $xc, $ptype) = split(/::/,$part);
             $left = sprintf("%.3f",$xc-$w/2+$packagekeepout);
             $right = sprintf("%.3f",$xc+$w/2+$packagekeepout);
             $top = sprintf("%.3f",$yc+$l/2+$packagekeepout);
             $bottom = sprintf("%.3f",$yc-$l/2+$packagekeepout);
             $xtest = sprintf("%.3f",($tempx2 + $tempx1) / 2);
             $ytest = sprintf("%.3f",($tempy2 + $tempy1) / 2);
             if ($xtest > $left && $xtest < $right && $ytest > $bottom && $ytest < $top) {$showtriangle=0;last}
            }
          }
          if ($showtriangle){
            push @binary, 0,0,$sign."1";
            push @binary, $tempx1, $tempy1, $ptz[$_[0]];
            if ($sign eq "") {
              push @binary, $tempx2, $tempy1, $ptz[$_[0]];
            }
            push @binary, $tempx1, $tempy2, $ptz[$_[0]];
            if ($sign eq "-") {
              push @binary, $tempx2, $tempy1, $ptz[$_[0]];
            }
            push @binary, 0;
            push @binary, 0,0,$sign."1";
            push @binary, $tempx2, $tempy1, $ptz[$_[0]];
            if ($sign eq "") {
              push @binary, $tempx2, $tempy2, $ptz[$_[0]];
            }
            push @binary, $tempx1, $tempy2, $ptz[$_[0]];
            if ($sign eq "-") {
              push @binary, $tempx2, $tempy2, $ptz[$_[0]];
            }
            push @binary, 0;
            $polygons += 2;
          }
        }
      }
    }
  }
}

sub planexz {
  $xx1=$ptx[$_[0]];  $xx2=$ptx[$_[2]];  $zz1=$ptz[$_[0]];  $zz2=$ptz[$_[2]];
  for ($i=0; $i<@xpoints; $i++) {
    if    ($xpoints[$i] > $xx2) { last }
    elsif ($xpoints[$i] == $xx1) { $tempx2 = $xpoints[$i] }
    elsif ($xpoints[$i] > $xx1 && $xpoints[$i] <= $xx2) {
      $tempx1 = $tempx2; $tempx2 = $xpoints[$i];
      for ($j=0; $j<@zpoints; $j++) {
        if    ($zpoints[$j] > $zz2) { last }
        elsif ($zpoints[$j] == $zz1) { $tempz2 = $zpoints[$j] }
        elsif ($zpoints[$j] > $zz1 && $zpoints[$j] <= $zz2) {
          $tempz1 = $tempz2; $tempz2 = $zpoints[$j];
          push @binary, 0,$sign."1",0;
          push @binary, $tempx1, $pty[$_[0]], $tempz1 ;
          if ($sign eq "-") {
            push @binary, $tempx2, $pty[$_[0]], $tempz1 ;
          }
          push @binary, $tempx1, $pty[$_[0]], $tempz2 ;
          if ($sign eq "") {
            push @binary, $tempx2, $pty[$_[0]], $tempz1 ;
          }
          push @binary, 0;
          push @binary, 0,$sign."1",0;
          push @binary, $tempx2, $pty[$_[0]], $tempz1 ;
          if ($sign eq "-") {
            push @binary, $tempx2, $pty[$_[0]], $tempz2 ;
          }
          push @binary, $tempx1, $pty[$_[0]], $tempz2 ;
          if ($sign eq "") {
            push @binary, $tempx2, $pty[$_[0]], $tempz2 ;
          }
          push @binary, 0;
          $polygons += 2;
        }
      }
    }
  }
}

sub planeyz {
  $zz1=$ptz[$_[0]];  $zz2=$ptz[$_[2]];  $yy1=$pty[$_[0]];  $yy2=$pty[$_[2]];
  for ($i=0; $i<@zpoints; $i++) {
    if    ($zpoints[$i] > $zz2) { last }
    elsif ($zpoints[$i] == $zz1) { $tempz2 = $zpoints[$i] }
    elsif ($zpoints[$i] > $zz1 && $zpoints[$i] <= $zz2) {
      $tempz1 = $tempz2; $tempz2 = $zpoints[$i];
      for ($j=0; $j<@ypoints; $j++) {
        if    ($ypoints[$j] > $yy2) { last }
        elsif ($ypoints[$j] == $yy1) { $tempy2 = $ypoints[$j] }
        elsif ($ypoints[$j] > $yy1 && $ypoints[$j] <= $yy2) {
          $tempy1 = $tempy2; $tempy2 = $ypoints[$j];
          push @binary, $sign."1",0,0;
          push @binary, $ptx[$_[0]], $tempy1, $tempz1 ;
          if ($sign eq "-") {
            push @binary, $ptx[$_[0]], $tempy1, $tempz2 ;
          }
          push @binary, $ptx[$_[0]], $tempy2, $tempz1 ;
          if ($sign eq "") {
            push @binary, $ptx[$_[0]], $tempy1, $tempz2 ;
          }
          push @binary, 0;
          push @binary, $sign."1",0,0;
          push @binary, $ptx[$_[0]], $tempy1, $tempz2 ;
          if ($sign eq "-") {
            push @binary, $ptx[$_[0]], $tempy2, $tempz2 ;
          }
          push @binary, $ptx[$_[0]], $tempy2, $tempz1 ;
          if ($sign eq "") {
            push @binary, $ptx[$_[0]], $tempy2, $tempz2 ;
          }
          push @binary, 0;
          $polygons += 2;
        }
      }
    }
  }
}


#------- Create the STL file ----------------------
if ($showstl) {

$tempx1=0;$tempx2=0;$tempy1=0;$tempy2=0;

$z1=sprintf("%.3f",$packagethickness);
$z2=sprintf("%.3f",$packagethickness+$wirebondledgeheight);
$z3=sprintf("%.3f",$packagethickness+$wirebondledgeheight+$sealringheight);

$x1=sprintf("%.3f",$leadledgewidth);
$x2=sprintf("%.3f",$x1+$sealringkeepout);
$x3=sprintf("%.3f",$x2+$sealringwidth);
$x4=sprintf("%.3f",$x3+$wirebondledgewidth);
$x5=sprintf("%.3f",$x4+$dropinkeepout);
$x11=sprintf("%.3f",$px);
$x10=sprintf("%.3f",$x11-$leadledgewidth);
$x9=sprintf("%.3f",$x10-$sealringkeepout);
$x8=sprintf("%.3f",$x9-$sealringwidth);
$x7=sprintf("%.3f",$x8-$wirebondledgewidth);
$x6=sprintf("%.3f",$x7-$dropinkeepout);

$y1=sprintf("%.3f",$leadledgewidth);
$y2=sprintf("%.3f",$y1+$sealringkeepout);
$y3=sprintf("%.3f",$y2+$sealringwidth);
$y4=sprintf("%.3f",$y3+$wirebondledgewidth);
$y5=sprintf("%.3f",$y4+$dropinkeepout);
$y11=sprintf("%.3f",$py);
$y10=sprintf("%.3f",$y11-$leadledgewidth);
$y9=sprintf("%.3f",$y10-$sealringkeepout);
$y8=sprintf("%.3f",$y9-$sealringwidth);
$y7=sprintf("%.3f",$y8-$wirebondledgewidth);
$y6=sprintf("%.3f",$y7-$dropinkeepout);

push @xpoints, (0,$x1,$x2,$x3,$x4,$x5,$x6,$x7,$x8,$x9,$x10,$x11);
push @ypoints, (0,$y1,$y2,$y3,$y4,$y5,$y6,$y7,$y8,$y9,$y10,$y11);
push @zpoints, (0,$z1,$z2,$z3);

%seen = ();@uniq = ();
foreach $item (@xpoints) { push (@uniq, $item) unless $seen{$item}++; }
@xpoints = sort { $a <=> $b} @uniq;
%seen = ();@uniq = ();
foreach $item (@ypoints) { push (@uniq, $item) unless $seen{$item}++; }
@ypoints = sort { $a <=> $b} @uniq;
%seen = ();@uniq = ();
foreach $item (@zpoints) { push (@uniq, $item) unless $seen{$item}++; }
@zpoints = sort { $a <=> $b} @uniq;

#-creat common points for triangle - @ptx @pty @ptz
$ptx[0] = 0;
$pty[0] = 0;
$ptz[0] = 0;

$ptx[1] = $x11;
$pty[1] = 0;
$ptz[1] = 0;

$ptx[2] = $x11;
$pty[2] = $y11;
$ptz[2] = 0;

$ptx[3] = 0;
$pty[3] = $y11;
$ptz[3] = 0;

$ptx[4] = 0;
$pty[4] = 0;
$ptz[4] = $z1;

$ptx[5] = $x11;
$pty[5] = 0;
$ptz[5] = $z1;

$ptx[6] = $x11;
$pty[6] = $y11;
$ptz[6] = $z1;

$ptx[7] = 0;
$pty[7] = $y11;
$ptz[7] = $z1;

$ptx[8] = $x1;
$pty[8] = $y1;
$ptz[8] = $z1;

$ptx[9] = $x10;
$pty[9] = $y1;
$ptz[9] = $z1;

$ptx[10] = $x10;
$pty[10] = $y10;
$ptz[10] = $z1;

$ptx[11] = $x1;
$pty[11] = $y10;
$ptz[11] = $z1;

$ptx[12] = $x1;
$pty[12] = $y1;
$ptz[12] = $z2;

$ptx[13] = $x10;
$pty[13] = $y1;
$ptz[13] = $z2;

$ptx[14] = $x10;
$pty[14] = $y10;
$ptz[14] = $z2;

$ptx[15] = $x1;
$pty[15] = $y10;
$ptz[15] = $z2;

$ptx[16] = $x2;
$pty[16] = $y2;
$ptz[16] = $z2;

$ptx[17] = $x9;
$pty[17] = $y2;
$ptz[17] = $z2;

$ptx[18] = $x9;
$pty[18] = $y9;
$ptz[18] = $z2;

$ptx[19] = $x2;
$pty[19] = $y9;
$ptz[19] = $z2;

$ptx[20] = $x2;
$pty[20] = $y2;
$ptz[20] = $z3;

$ptx[21] = $x9;
$pty[21] = $y2;
$ptz[21] = $z3;

$ptx[22] = $x9;
$pty[22] = $y9;
$ptz[22] = $z3;

$ptx[23] = $x2;
$pty[23] = $y9;
$ptz[23] = $z3;

$ptx[24] = $x3;
$pty[24] = $y3;
$ptz[24] = $z3;

$ptx[25] = $x8;
$pty[25] = $y3;
$ptz[25] = $z3;

$ptx[26] = $x8;
$pty[26] = $y8;
$ptz[26] = $z3;

$ptx[27] = $x3;
$pty[27] = $y8;
$ptz[27] = $z3;

$ptx[28] = $x3;
$pty[28] = $y3;
$ptz[28] = $z2;

$ptx[29] = $x8;
$pty[29] = $y3;
$ptz[29] = $z2;

$ptx[30] = $x8;
$pty[30] = $y8;
$ptz[30] = $z2;

$ptx[31] = $x3;
$pty[31] = $y8;
$ptz[31] = $z2;

$ptx[32] = $x4;
$pty[32] = $y4;
$ptz[32] = $z2;

$ptx[33] = $x7;
$pty[33] = $y4;
$ptz[33] = $z2;

$ptx[34] = $x7;
$pty[34] = $y7;
$ptz[34] = $z2;

$ptx[35] = $x4;
$pty[35] = $y7;
$ptz[35] = $z2;

$ptx[36] = $x4;
$pty[36] = $y4;
$ptz[36] = $z1;

$ptx[37] = $x7;
$pty[37] = $y4;
$ptz[37] = $z1;

$ptx[38] = $x7;
$pty[38] = $y7;
$ptz[38] = $z1;

$ptx[39] = $x4;
$pty[39] = $y7;
$ptz[39] = $z1;

$ptx[40] = $x5;
$pty[40] = $y5;
$ptz[40] = $z1;

$ptx[41] = $x6;
$pty[41] = $y5;
$ptz[41] = $z1;

$ptx[42] = $x6;
$pty[42] = $y6;
$ptz[42] = $z1;

$ptx[43] = $x5;
$pty[43] = $y6;
$ptz[43] = $z1;

$ptx[44] = $x5;
$pty[44] = $y5;
$ptz[44] = $z2;

$ptx[45] = $x6;
$pty[45] = $y5;
$ptz[45] = $z2;

$ptx[46] = $x6;
$pty[46] = $y6;
$ptz[46] = $z2;

$ptx[47] = $x5;
$pty[47] = $y6;
$ptz[47] = $z2;

#------- special points for HOR ----

$ptx[48] = $x1;
$pty[48] = 0;
$ptz[48] = $z1;

$ptx[49] = $x10;
$pty[49] = 0;
$ptz[49] = $z1;

$ptx[50] = $x10;
$pty[50] = $y11;
$ptz[50] = $z1;

$ptx[51] = $x1;
$pty[51] = $y11;
$ptz[51] = $z1;

$ptx[52] = $x2;
$pty[52] = $y1;
$ptz[52] = $z2;

$ptx[53] = $x9;
$pty[53] = $y1;
$ptz[53] = $z2;

$ptx[54] = $x9;
$pty[54] = $y10;
$ptz[54] = $z2;

$ptx[55] = $x2;
$pty[55] = $y10;
$ptz[55] = $z2;

$ptx[56] = $x3;
$pty[56] = $y2;
$ptz[56] = $z3;

$ptx[57] = $x8;
$pty[57] = $y2;
$ptz[57] = $z3;

$ptx[58] = $x8;
$pty[58] = $y9;
$ptz[58] = $z3;

$ptx[59] = $x3;
$pty[59] = $y9;
$ptz[59] = $z3;

$ptx[60] = $x4;
$pty[60] = $y3;
$ptz[60] = $z2;

$ptx[61] = $x7;
$pty[61] = $y3;
$ptz[61] = $z2;

$ptx[62] = $x7;
$pty[62] = $y8;
$ptz[62] = $z2;

$ptx[63] = $x4;
$pty[63] = $y8;
$ptz[63] = $z2;

$ptx[64] = $x5;
$pty[64] = $y4;
$ptz[64] = $z1;

$ptx[65] = $x6;
$pty[65] = $y4;
$ptz[65] = $z1;

$ptx[66] = $x6;
$pty[66] = $y7;
$ptz[66] = $z1;

$ptx[67] = $x5;
$pty[67] = $y7;
$ptz[67] = $z1;

# XY horizontal ----
#-package base
$sign="-";planexy 0,3,2,1;
#-package top
$sign="";planexy 4,48,51,7;
$sign="";planexy 48,49,9,8;
$sign="";planexy 49,5,6,50;
$sign="";planexy 11,10,50,51;
#-sealring keepout (ledge outside)
$sign="";planexy 12,52,55,15;
$sign="";planexy 52,53,17,16;
$sign="";planexy 53,13,14,54;
$sign="";planexy 19,18,54,55;
#-sealring top
$sign="";planexy 20,56,59,23;
$sign="";planexy 56,57,25,24;
$sign="";planexy 57,21,22,58;
$sign="";planexy 27,26,58,59;
if ($dropin) {
  #-ledge inside
  $sign="";planexy 28,60,63,31;
  $sign="";planexy 60,61,33,32;
  $sign="";planexy 61,29,30,62;
  $sign="";planexy 35,34,62,63;
  #-gap
  $sign="";planexy 36,64,67,39;
  $sign="";planexy 64,65,41,40;
  $sign="";planexy 65,37,38,66;
  $sign="";planexy 43,42,66,67; }
#-substrate
$testtriangle=1;
$sign="";planexy 44,45,46,47;
$testtriangle=0;

# XZ vertical bottom top
#-package
$sign="-";planexz 0,1,5,4;
$sign="";planexz 3,7,6,2;
if ($dropin) {
  #-ledge outside
  $sign="-";planexz 8,9,13,12;
  $sign="";planexz 11,15,14,10;}
#-sealring outside
$sign="-";planexz 16,17,21,20;
$sign="";planexz 19,23,22,18;
#-sealring inside
$sign="";planexz 28,24,25,29;
$sign="-";planexz 31,30,26,27;
if ($dropin) {
  #-ledge inside
  $sign="";planexz 36,32,33,37;
  $sign="-";planexz 39,38,34,35;
  #-substrate outside
  $sign="-";planexz 40,41,45,44;
  $sign="";planexz 43,47,46,42;  }

# YZ vertical left right
#-package
$sign="-";planeyz 0,4,7,3;
$sign="";planeyz 1,2,6,5;
if ($dropin) {
  #-ledge outside
  $sign="-";planeyz 8,12,15,11;
  $sign="";planeyz 9,10,14,13;}
#-sealring outside
$sign="-";planeyz 16,20,23,19;
$sign="";planeyz 17,18,22,21;
#-sealring inside
$sign="";planeyz 28,31,27,24;
$sign="-";planeyz 29,25,26,30;
if ($dropin) {
  #-ledge inside
  $sign="";planeyz 36,39,35,32;
  $sign="-";planeyz 37,33,34,38;
  #-substrate outside
  $sign="-";planeyz 40,44,47,43;
  $sign="";planeyz 41,42,46,45; }

if ($in{"ic0"} ne "888 888 888"){
for $part (@allparts) {
  ($l, $w, $t, $k, $yc, $xc, $ptype) = split(/::/,$part);
  $p0x = $xc - $w/2;
  $p0y = $yc - $l/2;
  $p0z = $z;
  $p1x = $xc + $w/2;
  $p1y = $yc - $l/2;
  $p1z = $z;
  $p2x = $xc + $w/2;
  $p2y = $yc + $l/2;
  $p2z = $z;
  $p3x = $xc - $w/2;
  $p3y = $yc + $l/2;
  $p3z = $z;
  $p4x = $xc - $w/2;
  $p4y = $yc - $l/2;
  $p4z = $z  + $t;
  $p5x = $xc + $w/2;
  $p5y = $yc - $l/2;
  $p5z = $z  + $t;
  $p6x = $xc + $w/2;
  $p6y = $yc + $l/2;
  $p6z = $z  + $t;
  $p7x = $xc - $w/2;
  $p7y = $yc + $l/2;
  $p7z = $z  + $t;
  $ptx[68] = sprintf("%.3f",$p0x+$packagekeepout);
  $pty[68] = sprintf("%.3f",$p0y+$packagekeepout);
  $ptz[68] = sprintf("%.3f",$p0z);
  $ptx[69] = sprintf("%.3f",$p1x+$packagekeepout);
  $pty[69] = sprintf("%.3f",$p1y+$packagekeepout);
  $ptz[69] = sprintf("%.3f",$p1z);
  $ptx[70] = sprintf("%.3f",$p2x+$packagekeepout);
  $pty[70] = sprintf("%.3f",$p2y+$packagekeepout);
  $ptz[70] = sprintf("%.3f",$p2z);
  $ptx[71] = sprintf("%.3f",$p3x+$packagekeepout);
  $pty[71] = sprintf("%.3f",$p3y+$packagekeepout);
  $ptz[71] = sprintf("%.3f",$p3z);
  $ptx[72] = sprintf("%.3f",$p4x+$packagekeepout);
  $pty[72] = sprintf("%.3f",$p4y+$packagekeepout);
  $ptz[72] = sprintf("%.3f",$p4z);
  $ptx[73] = sprintf("%.3f",$p5x+$packagekeepout);
  $pty[73] = sprintf("%.3f",$p5y+$packagekeepout);
  $ptz[73] = sprintf("%.3f",$p5z);
  $ptx[74] = sprintf("%.3f",$p6x+$packagekeepout);
  $pty[74] = sprintf("%.3f",$p6y+$packagekeepout);
  $ptz[74] = sprintf("%.3f",$p6z);
  $ptx[75] = sprintf("%.3f",$p7x+$packagekeepout);
  $pty[75] = sprintf("%.3f",$p7y+$packagekeepout);
  $ptz[75] = sprintf("%.3f",$p7z);
  #-hor top
  $sign="";&planexy (72,73,74,75);
  #-YZ vert (left/right)
  $sign="-";&planeyz (68,72,75,71);
  $sign="";&planeyz (69,73,74,70);
  #-XZ vert (top/bottom)
  $sign="";&planexz (71,70,74,75);
  $sign="-";&planexz (68,69,73,72);
}
}

open(BINOUT,"> ../mcm/design/image".$icount.".stl" );
#binmode BINOUT;
print BINOUT pack("A80V","3D MCM Image", $polygons);
for ($i=0; $i<$#binary; $i+=13) {
#  print BINOUT pack("f12S",@binary[$i .. $i+12]);
  $temp = reverse pack("f",$binary[$i]);    print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+1]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+2]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+3]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+4]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+5]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+6]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+7]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+8]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+9]);  print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+10]); print BINOUT $temp;
  $temp = reverse pack("f",$binary[$i+11]); print BINOUT $temp;
  print BINOUT    pack("S",$binary[$i+12]);
}
close (BINOUT);

print OUT "<p>\nThe STL file consists of $polygons triangles - derived from "
.scalar(@xpoints)." x-points, ".scalar(@ypoints).
" y-points and ".scalar(@zpoints)." z-points.";
}

if ($measure) { $timerresult20 = tv_interval ( $t0 );}

if ($measure) {
print OUT "<br> @xpoints";
print OUT "<br>\n";
print OUT "@ypoints";
print OUT "<br>\n";
print OUT "@zpoints";
print OUT "<br>\n";

print OUT "\n <table>";
print OUT "\n <tr><td>components:  <td>$timerresult1<br>";
print OUT "\n <tr><td>area/power:  <td>$timerresult2<br>";
print OUT "\n <tr><td>placement:   <td>$timerresult3<br>";
print OUT "\n <tr><td>parts:       <td>$timerresult4<br>";
print OUT "\n <tr><td>pkg size:    <td>$timerresult5<br>";
print OUT "\n <tr><td>I/O calc:    <td>$timerresult6<br>";
print OUT "\n <tr><td>package:     <td>$timerresult7<br>";
print OUT "\n <tr><td>substrate: <td>$timerresult8<br>";
print OUT "\n <tr><td>interconnect: <td>$timerresult9<br>";
print OUT "\n <tr><td>sealring: <td>$timerresult10<br>";
print OUT "\n <tr><td>lid: <td>$timerresult11<br>";
print OUT "\n <tr><td>wirebondledge: <td>$timerresult12<br>";
print OUT "\n <tr><td>solder balls: <td>$timerresult13<br>";
print OUT "\n <tr><td>wirebonds: <td>$timerresult14<br>";
print OUT "\n <tr><td>leads: <td>$timerresult15<br>";
print OUT "\n <tr><td>pads: <td>$timerresult16<br>";
print OUT "\n <tr><td>imageXX.txt: <td>$timerresult17<br>";
print OUT "\n <tr><td>imageXX.htm: <td>$timerresult18<br>";
print OUT "\n <tr><td>STL: <td>$timerresult19<br>";
print OUT "\n <tr><td>end: <td>$timerresult20<br>";
print OUT "\n </table>";
}

print OUT <<stop_html44;
    </ul>
</table>
</body>
</html>
stop_html44

close OUT;

#------- Send to the newly created image.htm ----------------------
chmod 0755 , "../mcm/design/image".$icount.".txt";
chmod 0755 , "../mcm/design/image".$icount.".htm";
print "Location: http://www.garybeene.com/mcm/design/image".$icount.".htm\n\n";
#print "Location: http://127.0.0.1/mcm/design/image".$icount.".htm\n\n";