#Compile Exe
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32API.inc"
#Include "CommCtrl.inc"
#Resource "gbdesigner.pbr"     'misc icons

Type PointX
    X As Single : Y As Single : Z As Single
    Xo As Single : Yo As Single : Zo As Single
    Xp As Single : Yp As Single
    ColorG As Long : Marker As Long
End Type

Type Cube
    P1 As PointX
    P2 As PointX
    P3 As PointX
    P4 As PointX
    P5 As PointX
    P6 As PointX
    P7 As PointX
    P8 As PointX
End Type

Type TriangleX
    p1 As Long     : p2 As Long       : p3 As Long
    ZDepthO As Single : ColorG As Long : ZDepth As Single : DotProduct As Single
End Type

Type Polypoints
    Count As Long
    x1 As Single : y1 As Single
    x2 As Single : y2 As Single
    x3 As Single : y3 As Single
End Type

Type CustomColors : c(15) As Long : End Type

Type MaterialType
    index As Long
    desc As String * 20
    thermcond As Long      'mW/C-in
    density As Long        'mgms/in3
End Type

Type PartType
   index As Long
   desc As String * 20
   x As Long
   y As Long
   z As Long
   xk As Long
   yk As Long
   xcenter As Long
   ycenter As Long
   area As Long
   placed As Long
   io As Long
   power As Long           ' mW         milliwatts
   thermalcond As Long     ' mW/C-in    milliwats
   density As Long         ' mgms/m3    milligrams/
   res1 As Long
   res2 As Long
   res3 As Long
   res4 As String * 20
   res5 As String * 20
End Type

Type MCMDesign
   Parts(250) As PartType
   ic As Long
   ires As Long
   iproc As Long
   icap As Long
   iasic As Long
   iother1 As Long
   iother2 As Long
   iother3 As Long
   IO As Long
   Interface As Long        ' 1-BGA 2-Leaded 3-PerimeterPads
   Interconnect As Long     ' 1-Integrated 2-dropin
   Constrain As Long        ' 1-yes 0-no
   Placement As Long        ' 1-Opt 2-Rnd 3-Std
   AspectRatio As Long      '1.0 thru 3.0 in 0.1 increments
   balls_pitch As Long
   balls_dia As Long
   pads_pitch As Long
   pads_length As Long
   pads_width As Long
   pads_thickness As Long
   leads_pitch As Long
   leads_length As Long
   leads_width As Long
   leads_thickness As Long
   leads_matl As Long           '1-kovar 2-copper
   ic_thickness As Long
   ic_wbpitch As Long
   ic_wbkeeoupt As Long
   ic_assykeepout As Long
   ic_padkeepout As Long
   ic_matl As Long              '1-thickfilm 2-thinfilm 3-laminate 4-RDL
   ic_subthickness As Long
   ic_submatl As Long           '1-silicon 2-ceramic 3-aluminumnitride
   pkg_thickness As Long
   pkg_dropinkeepout As Long
   pkg_wbledgewidth As Long
   pkg_wbledgeheight As Long
   pkg_sealringwidth As Long
   pkg_sealringkeeoput As Long
   pkg_sealringmatl As Long     '1-kovar 2-nickel 3-aluminum 4-plastic
   pkg_leadledgewidth As Long
   pkg_cornerkeepout As Long
   pkg_matl As Long             '1-ceramic 2-kovar 3-laminate 4-rdl
   lid_thickness As Long
   lid_keepout As Long
   lid_matl As Long             '1-kovar 2-aluminum 3-plastic
   th_partattachthickness As Long
   th_partattachmaterial As Long  '1-solder 2-epoxy 3-epoxy(cond)
   th_pkgattachthickness As Long
   th_pkgattachmaterial As Long   '1-solder 2-epoxy 3-expoy(cond)
   th_subattachthickness As Long
   th_subattachmaterial As Long '1-solder 2-epoxy 3-epoxy(cond)
   res1 As Long
   res2 As Long
   res3 As Long
   res4 As String * 20
   res5 As String * 20
End Type

'===================================================================================================
$ver = "1.0"
%IDC_Graphic = 500 : %IDC_Timer = 501 : %IDC_ToolbarA = 502 : %IDC_StatusBar = 503 : %IDC_TextBox = 504
%IDC_XMax = 521 : %IDC_XMin = 522 : %IDC_XStep = 523
%IDC_Title = 527    : %IDC_YMax = 524 : %IDC_YMin = 525 : %IDC_YStep = 526 : %IDC_ToolbarB = 528
%IDM_FileExportSTL = 800 : %IDM_FileExportTOV = 801 : %IDM_FileExit = 802

%IDC_Button = 850

'MCM Globals===================================================================================================

Global ShowPackage, ShowSubstrate, ShowInterconnect, ShowSealRing, ShowWireBondLedge As Long
Global ShowParts, ShowWireBonds, ShowLid, ShowSolderBalls, ShowLeads, ShowPads As Long
Global PL() As PartType, MCM As MCMDesign

'===================================================================================================

Global hDlg, hDC_Graphic, hToolBarA, hToolBarB, hLst, hPopup, hPopup2, hPopup3, hPopup4, hPopup5, hPopup6 As Dword
Global P(), POnly() As PointX, T() As TriangleX, OriginalPT, CurrentFileName As String
Global OffsetX, OffsetY, POV, Angle As Single
Global PointSize, Speed, PowerOn, RotateX, RotateY, RotateZ, DisplayType, BackFace, DepthSort As Long  'flags
Global BColor, BackColor, Gradient,  TextBoxStyle As Long
Global ModelType, Markers, LineColor, PointColor, TriangleColor, Projection, DataDisplay As Long
Global CustomColorList As CustomColors
Global XHigh, XLow, YHigh, YLow, ZHigh, ZLow, THigh, TLow, NoLine, FarthestPoint As Single
Global hMenu, hMenuFile, hFontNormal, hFontBold, hFontBold2 As Dword

Global hData As Dword
Global hs,vs,Horz,Vert,wMax, hMax As Long

Function PBMain()
    Font New "Arial", 13, 0 To hFontNormal
    Font New "Arial", 13, 1 To hFontBold
    Font New "Arial", 8, 1 To hFontBold2
    TextBoxStyle& = %WS_Border Or %ES_AutoVScroll Or %ES_MultiLine Or %ES_WantReturn Or %WS_VScroll
    Dialog New Pixels, 0, "gbMCM - MCM Concept Evaluator",,, 480,350, %WS_OverlappedWindow Or %WS_ClipChildren, To hDlg
    Dialog Set Icon hDlg, "face"
    AddMenu : AddToolbar : AddStatusBar : AddDesignControls
    Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local iReturn, XDelta,YDelta As Long, quadPipelineCycle As Quad, pt As Point, C As Cube
   Static quadTimerCycle As Quad, SpinInWork,XLast,YLast As Long, fName As String
   Select Case Cb.Msg
      Case %WM_InitDialog
         ReDim PL(0)
         Settings_INI "get"
         ModelType = 4
         CurrentFileName = "sphere.stla"
         LoadObjectFromFile CurrentFileName
         BuildLeftSide
         ScaleToFit : ShortPipeLine : DisplayInfo
         MakeTimer
      Case %WM_Size
         ResizeDialog
      Case %WM_Destroy
         Settings_INI "save"
         Dialog End hData
      Case %WM_Timer
         Tix End quadTimerCycle
         Tix quadPipelineCycle
         If PowerOn Then PipeLine(Angle)
         Tix End quadPipelineCycle
         Statusbar Set Text hDlg, %IDC_Statusbar, 3, 0, Format$(quadPipelineCycle/quadTimerCycle, "0.00%")
         Tix quadTimerCycle
      Case %WM_GETMINMAXINFO
         If IsFalse(IsIconic(hDlg)) Then
            Local MM As MINMAXINFO Ptr
            MM=Cb.LParam
            @MM.ptMinTrackSize.x=650  '<-- Min X size of your window
            @MM.ptMinTrackSize.y=670  '<-- Min Y size of your window
            @MM.ptMaxTrackSize.x=9999  '<-- Max X size of your window
            @MM.ptMaxTrackSize.y=9999  '<-- Max Y size of your window
         End If

      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
           Case > 0  : ChangeSize 1  : ShortPipeLine
           Case < 0  : ChangeSize -1 : ShortPipeLine
         End Select

      Case %WM_SetCursor
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemose, lbuttonup
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If PowerOn = 0 Then                       'cannot use mouse when power is on
                  iReturn = GetDlgCtrlID (Cb.WParam)
                  If iReturn = %IDC_Graphic Then
                     SpinInWork = 1
                     GetCursorPos pt                      'pt has xy screen coordinates
                     ScreenToClient hDC_Graphic, pt       'pt now has dialog client coordinates
                     XLast = Pt.x
                     YLast = Pt.y
                  End If
               End If
            Case %WM_MouseMove
               If SpinInWork Then
                  GetCursorPos pt                      'pt has xy screen coordinates
                  ScreenToClient hDC_Graphic, pt       'pt now has dialog client coordinates
                  XDelta = XLast - Pt.x
                  YDelta = YLast - Pt.y
                  If RotateY Then RotateAboutXAxis YDelta * 0.02      : ShortPipeline
                  If RotateX Then RotateAboutYAxis XDelta * 0.02 * -1 : ShortPipeline
                  XLast = pt.x
                  YLast = pt.y
               End If
            Case %WM_LButtonUp
               SpinInWork = 0
         End Select


      Case %WM_Command
         Select Case Cb.Ctl
            Case 899
               Static OneTime As Long
               If OneTIme = 0 Then
                   OneTime = 1
                   ReDim P(0) : ReDim POnly(0) : ReDim T(0)
               End If
               CreateMCM : ShortPipeLine : DisplayInfo
            Case %IDC_Graphic
                If Cb.CtlMsg = %STN_DblClk Then ResetModel : ScaleToFit : ShortPipeLine
            Case %IDM_FileExit      : Dialog End hDlg

            Case 201 :  PowerOn = PowerOn Xor 1
            Case 202 :  RotateX = RotateX Xor 1
            Case 203 :  RotateY = RotateY Xor 1
            Case 204 :  RotateZ = RotateZ Xor 1

            Case 205 :  DisplayType = 1 : ShortPipeline : DisplayInfo  'points
            Case 206 :  DisplayType = 2 : ShortPipeline : DisplayInfo  'lines
            Case 207 :  DisplayType = 3 : ShortPipeline : DisplayInfo  'triangles

            Case 208 :  BackFace = BackFace Xor 1     : ShortPipeline : DisplayInfo
            Case 209 :  DepthSort = DepthSort Xor 1   : ShortPipeline : DisplayInfo
            Case 222 :  Projection = Projection Xor 1 : ShortPipeline : DisplayInfo

            Case 230 :  DataDisplay = DataDisplay Xor 1
                        BuildLeftSide : ResizeDialog
            Case 234 :  DisplayHelp

            Case 215 :  Gradient = Gradient Xor 1 : DrawObject   : DisplayInfo  'Gradient
            Case 216 :  Markers = Markers Xor 1   : DrawObject   : DisplayInfo  'Marker
            Case 227 :  NoLine = NoLine Xor 1     : DrawObject   : DisplayInfo  'Marker

            Case 218 :  ResetModel : ScaleToFit : ShortPipeLine
            Case 219 :  If PowerOn = 0 Then PipeLine(Angle)

            Case 210 :  CycleModel : BuildLeftSide : ScaleToFit : ShortPipeLine : DisplayInfo
            Case 220
                fName = SelectFileToOpen
                If IsFile(fName) Then
                    ModelType = 4
                    CurrentFileName = fName
                    LoadObjectFromFile CurrentFileName
                Else
                    MsgBox "Bad file name!"
                End If
                ScaleToFit : ShortPipeLine : DisplayInfo

            Case 225 : ChangeSize 1  : ShortPipeLine
            Case 226 : ChangeSize -1 : ShortPipeLine

            Case 211 :  CycleSpeed                                      : ShortPipeLine : DisplayInfo : MakeTimer
            Case 212 :  CycleAngle                                      : ShortPipeLine : DisplayInfo
            Case 213 :  CyclePointSize                                  : ShortPipeLine : DisplayInfo
            Case 214 :  CycleColors     : Graphic Color %Black, BColor  : ShortPipeline

            Case 235 :  MoveLeft  : ShortPipeLine : DisplayInfo
            Case 236 :  MoveRight : ShortPipeLine : DisplayInfo
            Case 237 :  MoveUp    : ShortPipeLine : DisplayInfo
            Case 238 :  MoveDown  : ShortPipeLine : DisplayInfo

            Case 239 :  DisplayDatadialog

            Case 303
                If IsFile(CurrentFileName) Then
                    ModelType = 4 : BuildLeftSide
                    LoadSTLAFile CurrentFileName
                Else
                    MsgBox "Bad file name!"
                End If
                ScaleToFit : ShortPipeLine : DisplayInfo

            Case 400 :  Speed = 1   : DisplayInfo :  MakeTimer
            Case 401 :  Speed = 2   : DisplayInfo :  MakeTimer
            Case 402 :  Speed = 5   : DisplayInfo :  MakeTimer
            Case 403 :  Speed = 10  : DisplayInfo :  MakeTimer
            Case 404 :  Speed = 20  : DisplayInfo :  MakeTimer
            Case 405 :  Speed = 40  : DisplayInfo :  MakeTimer
            Case 406 :  Speed = 60  : DisplayInfo :  MakeTimer
            Case 407 :  Speed = 80  : DisplayInfo :  MakeTimer
            Case 408 :  Speed = 100 : DisplayInfo :  MakeTimer
            Case 409 :  Speed = 250 : DisplayInfo :  MakeTimer
            Case 410 :  Speed = 500 : DisplayInfo :  MakeTimer

            Case 420 :  Angle = 0.01 : DisplayInfo
            Case 421 :  Angle = 0.02 : DisplayInfo
            Case 422 :  Angle = 0.03 : DisplayInfo
            Case 423 :  Angle = 0.04 : DisplayInfo
            Case 424 :  Angle = 0.05 : DisplayInfo
            Case 425 :  Angle = 0.10 : DisplayInfo
            Case 426 :  Angle = 0.20 : DisplayInfo

            Case 440 :  PointSize = 1  : ShortPipeLine : DisplayInfo
            Case 441 :  PointSize = 2  : ShortPipeLine : DisplayInfo
            Case 442 :  PointSize = 3  : ShortPipeLine : DisplayInfo
            Case 443 :  PointSize = 4  : ShortPipeLine : DisplayInfo
            Case 444 :  PointSize = 5  : ShortPipeLine : DisplayInfo
            Case 445 :  PointSize = 10 : ShortPipeLine : DisplayInfo
            Case 446 :  PointSize = 25 : ShortPipeLine : DisplayInfo
            Case 447 :  PointSize = 50 : ShortPipeLine : DisplayInfo

            Case 460 :  BackColor = GetColor (BColor)  : BColor = BackColor : Graphic Color %Black, BColor : ShortPipeLine 'point
            Case 461 :  PointColor = GetColor (PointColor)        : ShortPipeLine 'point
            Case 462 :  LineColor = GetColor (LineColor)          : ShortPipeLine 'line
            Case 463 :  TriangleColor = GetColor (TriangleColor)  : ShortPipeLine 'planes


         End Select
      Case %WM_Notify
         Local nmtb As TBNOTIFY Ptr, rc As RECT
         nmtb = Cb.LParam
         Select Case @nmtb.hdr.Code
             Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                     Case 210
                         SendMessage(hToolbarA, %TB_GETRECT, 210, VarPtr(rc))
                         MapWindowPoints(hToolbarA, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 211
                         SendMessage(hToolbarB, %TB_GETRECT, 211, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp2, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 212
                         SendMessage(hToolbarB, %TB_GETRECT, 212, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp3, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 213
                         SendMessage(hToolbarB, %TB_GETRECT, 213, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp4, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 214
                         SendMessage(hToolbarB, %TB_GETRECT, 214, VarPtr(rc))
                         MapWindowPoints(hToolbarB, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp5, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                     Case 221
                         SendMessage(hToolbarA, %TB_GETRECT, 221, VarPtr(rc))
                         MapWindowPoints(hToolbarA, %HWND_Desktop, ByVal VarPtr(rc), 2)
                         TrackPopupMenu (hPopUp6, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                 End Select
         End Select
         If Cb.NmCode = %TTN_GetDispInfo Then
            Local TT As TOOLTIPTEXT Ptr
               TT = Cb.LParam
               Select Case Cb.NmId          'or this:   @P.hdr.idFrom
                  Case 201 : @TT.@lpszText = "Automatic Rotation"
                  Case 202 : @TT.@lpszText = "Spin Around X Axis"
                  Case 203 : @TT.@lpszText = "Spin Around Y Axis"
                  Case 204 : @TT.@lpszText = "Spin Around Z Axis"
                  Case 218 : @TT.@lpszText = "Reset Model to Initial Position"
                  Case 219 : @TT.@lpszText = "Step Through a Single Rotation Cycle"
                  Case 205 : @TT.@lpszText = "Display Points Only"
                  Case 206 : @TT.@lpszText = "Display Lines Only"
                  Case 207 : @TT.@lpszText = "Display Surfaces Only"
                  Case 210 : @TT.@lpszText = "Select Model To Display"
                  Case 220 : @TT.@lpszText = "Select File To Display"
                  Case 208 : @TT.@lpszText = "Implement Backface Culling"
                  Case 209 : @TT.@lpszText = "Implement Depth Sorting"
                  Case 222 : @TT.@lpszText = "Implement POV Projection"
                  Case 215 : @TT.@lpszText = "Use Gradient Colors"
                  Case 216 : @TT.@lpszText = "Display Markers (Point Mode Only)"
                  Case 211 : @TT.@lpszText = "Cycle Through/Select Timer Period"
                  Case 212 : @TT.@lpszText = "Cycle Through/Select Rotation Angle"
                  Case 213 : @TT.@lpszText = "Cycle Through/Select Point Size"
                  Case 214 : @TT.@lpszText = "Cycle Through/Select Colors"
                  Case 234 : @TT.@lpszText = "Display Operating Instructions"
                  Case 225 : @TT.@lpszText = "Zoom In (temporary)"
                  Case 226 : @TT.@lpszText = "Zoom Out (temporary)"
                  Case 235 : @TT.@lpszText = "Move the Model Left (temporary)"
                  Case 236 : @TT.@lpszText = "Move the Model Right (temporary)"
                  Case 237 : @TT.@lpszText = "Move the Model Up (temporary)"
                  Case 238 : @TT.@lpszText = "Move the Model Down (temporary)"
                  Case 239 : @TT.@lpszText = "Display Data Editor Dialog"
                  Case 230 : @TT.@lpszText = "Display Model Data"
                  Case 227 : @TT.@lpszText = "Hide Lines When Dislaying Surfaces"
               End Select
         End If

   End Select
End Function

Sub ResizeDialog
   If IsIconic(hDlg) Then Exit Sub
   Local w,h As Long
   SendMessage(hDlg, %WM_SETREDRAW, 0, 0)  'Turn off redraw for faster and smoother action
   Dialog Get Client hDlg To w,h
   Control Kill hdlg, %IDC_Graphic
   If DataDisplay Then
      'controls visible on left
      Control Add Graphic, hDlg, %IDC_Graphic, "", 400,90,w-415,h-120, %WS_Border Or %SS_Notify
      OffsetX = (w-415)/2  :  OffsetY = (h-120)/2
      Control Handle hDlg, %IDC_Graphic To hDC_Graphic
      Control Set Size hDlg, %IDC_TextBox, 175,h-120      'Equation controls are not visible
   Else
      'graphic control only
      Control Add Graphic, hDlg, %IDC_Graphic, "", 10,90,w-20,h-120, %WS_Border Or %SS_Notify
      OffsetX = (w-20)/2  :  OffsetY = (h-120)/2
      Control Handle hDlg, %IDC_Graphic To hDC_Graphic
   End If

   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color %Black, BColor
   ScaleToFit
   ShortPipeline
   SendMessage hDlg, %WM_SETREDRAW, 1, 0   'Turn on redraw again and refresh
   Dialog ReDraw hDlg
   Graphic ReDraw
   DisplayInfo
End Sub

Sub PipeLine(Ang As Single)
    Local i As Long
    If RotateX Then RotateAboutXAxis(Ang)
    If RotateY Then RotateAboutYAxis(Ang)
    If RotateZ Then RotateAboutZAxis(Ang)
    If DepthSort = 1 Then
       If DisplayType = 1 Then SortPointsByZDepth
       If DisplayType = 2 Then SortTrianglesByZDepth
       If DisplayType = 3 Then SortTrianglesByZDepth
    ElseIf DisplayType = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If BackFace = 1 And DisplayType = 3 Then BackFaceCulling
    ProjectToScreen
    DrawObject
End Sub

Sub ShortPipeLine
    Local i As Long
    Graphic Clear
    If DepthSort = 1 Then
       If DisplayType = 1 Then SortPointsByZDepth
       If DisplayType = 2 Then SortTrianglesByZDepth
       If DisplayType = 3 Then SortTrianglesByZDepth
    ElseIf DisplayType = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If BackFace = 1 And DisplayType = 3 Then BackFaceCulling
    ProjectToScreen
    DrawObject
    Graphic ReDraw
End Sub

Sub RotateAboutXAxis(Ang As Single)
   Local i As Long, NewY, NewZ As Single
   For i = 1 To UBound(P)
      NewY = P(i).Y * Cos(Ang) - P(i).Z * Sin(Ang)    'X rotation
      NewZ = P(i).Y * Sin(Ang) + P(i).Z * Cos(Ang)    'X rotation
      P(i).Y = NewY : P(i).Z = NewZ
   Next i
End Sub

Sub RotateAboutYAxis(Ang As Single)
   Local i As Long, NewX, NewZ As Single
   For i = 1 To UBound(P)
      NewX = P(i).Z * Sin(Ang) + P(i).X * Cos(Ang)    'Y rotation
      NewZ = P(i).Z * Cos(Ang) - P(i).X * Sin(Ang)    'Y rotation
      P(i).X = NewX : P(i).Z = NewZ
   Next I
End Sub

Sub RotateAboutZAxis(Ang As Single)
   Local i As Long, NewX, NewY As Single
   For i = 1 To UBound(P)
      NewX = P(i).X * Cos(Ang) - P(i).Y * Sin(Ang)    'Z rotation
      NewY = P(i).X * Sin(Ang) + P(i).Y * Cos(Ang)    'Z rotation
      P(i).X = NewX : P(i).Y = NewY
   Next i
End Sub

Sub SortPointsByZDepth
   Local i As Long
   For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
   Array Sort POnly(1), Using CustomPointSort          'sort POnly
End Sub

Function CustomPointSort(R As PointX, S As PointX) As Long
   'sorts in ascending order by .z element
   If R.z < S.z Then Function = -1 : Exit Function
   If R.z > S.z Then Function = +1 : Exit Function
End Function

Sub SortTrianglesByZDepth
   Local i As Long
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ZDepth = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
      Next i
      Array Sort T(1), Using CustomTriangleSort
   End If
End Sub

Function CustomTriangleSort(R As TriangleX, S As TriangleX) As Long
   'sorts in ascending order by .ZDepth element
   If R.ZDepth < S.ZDepth Then Function = -1 : Exit Function
   If R.ZDepth > S.ZDepth Then Function = +1 : Exit Function
End Function

Function BackFaceCulling() As Long
    Dim i As Long
    'use CrossProduct to find normal with (0,0,POV), put in P(0)
    'get DotProduct between point of view and normal
    If UBound(T) > 0 Then
       For i = 1 To UBound(T)
          ComputeCrossProduct i
          T(i).DotProduct = ComputeDotProduct
       Next i
    End If
End Function

Sub ComputeCrossProduct(i As Long)
    Dim x1 As Single, y1 As Single, z1 As Single, x2 As Single, y2 As Single, z2 As Single
    'cross product defines a vector perpendicular to the triangle surface
    'uses right-hand rule of thumb rule, sequence of points defines the surface (counter-clockwise)
    'create position vectors to use in cross product
    'this code uses points P1P2 and P2P3 line segments
    'any 2 line segements from the triangle will do
    x1 = P(T(i).p2).X - P(T(i).p1).X    'position vector, x component
    y1 = P(T(i).p2).Y - P(T(i).p1).Y    'position vector, y component
    z1 = P(T(i).p2).Z - P(T(i).p1).Z    'position vector, z component

    x2 = P(T(i).p3).X - P(T(i).p1).X    'position vector, x component
    y2 = P(T(i).p3).Y - P(T(i).p1).Y    'position vector, y component
    z2 = P(T(i).p3).Z - P(T(i).p1).Z    'position vector, z component

    'put resulting cross product vector in P(0) - just a conveniently unused position in the array
    P(0).X = y1 * z2 - y2 * z1     'cross product vector, x component
    P(0).Y = x2 * z1 - x1 * z2     'cross product vector, y component
    P(0).Z = x1 * y2 - x2 * y1     'cross product vector, z component
End Sub

Function ComputeDotProduct() As Long
    'uses POV vector 0,0,POV  as x1,y1,z1
    'used cross product that was stored in P(0) as x2, y2, z2
    ComputeDotProduct = 0 * P(0).X + 0 * P(0).Y + POV * P(0).Z
End Function

Function ProjectToScreen() As Long
   Local i As Long
   If Projection Then
      'use POV to set xp/yp values
      For i = 1 To UBound(P)
         If DisplayType = 1 Then
            POnly(i).xp = POnly(i).x
            POnly(i).yp = POnly(i).y
         Else
            P(i).xp = P(i).x
            P(i).yp = P(i).y
         End If
      Next i
   Else
      'do NOT use POV to set xp/yp values
      For i = 1 To UBound(P)
         If DisplayType = 1 Then
            POnly(i).xp = POnly(i).x
            POnly(i).yp = POnly(i).y
         Else
            P(i).xp = P(i).x
            P(i).yp = P(i).y
         End If
      Next i
   End If
End Function

Sub DrawObject()
   Local i,d,PColor,LColor,TColor As Long, x,y As Single, PTS As PolyPoints
   PTS.Count = 3
   Graphic Clear
   Select Case DisplayType
       Case 1     'points
          For i = 1 To UBound(POnly)
             If Gradient Then PColor = POnly(i).ColorG Else PColor = PointColor
             x = POnly(i).xp + OffsetX  : y = POnly(i).yp + OffsetY
             If Markers Then
                Select Case POnly(i).marker
                   Case -1    : d = PointSize + 4  : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Red, %Red, 0
                   Case 1     : d = PointSize + 12 : Graphic Ellipse (x-d,y-d)-(x+d,y+d), %Green, %Green, 0
                   Case Else  : Graphic Ellipse (x-PointSize,y-Pointsize)-(x+Pointsize,y+Pointsize), PColor, PColor, 0
                End Select
             Else
                Graphic Ellipse (x-PointSize,y-Pointsize)-(x+Pointsize,y+Pointsize), PColor, PColor, 0
             End If
          Next i
       Case 2
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                Graphic Polygon PTS, LineColor, -2, 0, 0              'Graphic Polyline PTS, LineColor
             Next i
          End If
       Case 3
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                If Gradient Then TColor = T(i).ColorG Else TColor = TriangleColor
                If NoLine Then LColor = TColor Else LColor = LineColor
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                If (BackFace = 1 And T(i).DotProduct > 0 ) Or BackFace = 0 Then
                   Graphic Polygon PTS, LColor, TColor, 0, 0
                End If
             Next i
          End If
   End Select
   Graphic ReDraw
End Sub

Sub LoadObjectFromFile (fName As String)
    MousePtr 11
    Select Case LCase$(Trim$(PathName$(Extn, fName), "."))
        Case "stla" : LoadSTLAFile(fName)
        Case "stlb" : LoadSTLBFile(fName)
    End Select
    MousePtr 0
End Sub

Sub LoadSTLAFile (fName As String)
    Local temp As String, i, iCount, iPoints, iTriangles As Long

    'verify file is right type
    Open fName For Input As #1
    Line Input #1, temp
    Close #1
    If Left$(LCase$(Trim$(temp)),5) <> "solid" Then Exit Sub

    'get count # Points and # triangles
    Open fName For Binary As #1
    Get$ #1, Lof(1), temp
    Close #1
    iCount = ParseCount(LCase$(temp), "endfacet") - 1
    ReDim P(iCount*3), POnly(iCount*3), T(iCount)

    'load into P(), POnly(), T()
    Open fName For Input As #1
    Line Input #1, temp    'header, discard
    For i = 1 To iCount
        Incr iTriangles

        Line Input #1, temp 'discard
        Line Input #1, temp 'discard

        Line Input #1, temp 'p1
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p1 = iPoints

        Line Input #1, temp 'p2
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p2 = iPoints

        Line Input #1, temp 'p3
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p3 = iPoints

        Line Input #1, temp ' discard
        Line Input #1, temp ' discard

    Next i
    Close #1

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub LoadSTLBFile (fName As String)
   Local temp As String * 80
   Local x,y,z As Single
   Local i, iPoints As Long
   Local iCount As Dword
   Local iSkip As Integer

   Open fName For Binary As #1
   Get #1, , temp
   Get #1, , iCount
   ReDim P(iCount*3), POnly(iCount*3), T(iCount)

   For i = 1 To iCount
       Get #1, , x : Get #1, , y : Get #1, , z  'discard

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p1 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p2 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p3 = iPoints

       Get #1, , iSkip
   Next i
   Close #1
   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub


Sub AddStatusBar
   Control Add Statusbar, hDlg, %IDC_Statusbar,"",0,0,0,0,%CCS_Bottom Or %SBars_SizeGrip
   Statusbar Set Parts hDlg, %IDC_StatusBar, 150, 150, 99999
End Sub

Sub AddToolbar
    'add toolbar1
    Control Add Toolbar, hDlg, %IDC_ToolbarA, "Toolbar",0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat
    Control Handle hDlg, %IDC_ToolbarA To hToolbarA
    SendMessage hToolbarA, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    'add toolbar2
    Control Add Toolbar, hDlg, %IDC_ToolbarB, "Toolbar",0,40,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %CCS_NoMoveY
    Control Handle hDlg, %IDC_ToolbarB To hToolbarB
    SendMessage hToolbarB, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    'create imagelist
    ImageList New Icon 16,16,32,3 To hLst
    ImageList Add Icon hLst, "stop"           '1
    ImageList Add Icon hLst, "x"              '2
    ImageList Add Icon hLst, "y"              '3
    ImageList Add Icon hLst, "z"              '4
    ImageList Add Icon hLst, "paint"          '5
    ImageList Add Icon hLst, "fill"           '6
    ImageList Add Icon hLst, "face"           '7
    ImageList Add Icon hLst, "grid"           '8
    ImageList Add Icon hLst, "line"           '9
    ImageList Add Icon hLst, "direction"      '10
    ImageList Add Icon hLst, "plane"          '11
    ImageList Add Icon hLst, "rocket"         '12
    ImageList Add Icon hLst, "rotate"         '13
    ImageList Add Icon hLst, "points"         '14
    ImageList Add Icon hLst, "picker"         '15
    ImageList Add Icon hLst, "sorta"          '16
    ImageList Add Icon hLst, "axis"           '17
    ImageList Add Icon hLst, "color"          '18
    ImageList Add Icon hLst, "delta"          '19
    ImageList Add Icon hLst, "eye"            '20
    ImageList Add Icon hLst, "gradient"       '21
    ImageList Add Icon hLst, "marks"          '22
    ImageList Add Icon hLst, "shimmer"        '23
    ImageList Add Icon hLst, "dots"           '24
    ImageList Add Icon hLst, "fx"             '25
    ImageList Add Icon hLst, "refresh"        '26
    ImageList Add Icon hLst, "one"            '27
    ImageList Add Icon hLst, "open"           '28
    ImageList Add Icon hLst, "fx"             '29
    ImageList Add Icon hLst, "new"            '30
    ImageList Add Icon hLst, "save"           '31
    ImageList Add Icon hLst, "point"          '32
    ImageList Add Icon hLst, "question"       '33
    ImageList Add Icon hLst, "add"            '34
    ImageList Add Icon hLst, "minus"          '35
    ImageList Add Icon hLst, "trim"           '36
    ImageList Add Icon hLst, "data"           '37
    ImageList Add Icon hLst, "lefthand"       '38
    ImageList Add Icon hLst, "righthand"      '39
    ImageList Add Icon hLst, "uphand"         '40
    ImageList Add Icon hLst, "downhand"       '41
    ImageList Add Icon hLst, "delete"         '42
    ImageList Add Icon hLst, "setup"          '43

    'attach imagelist
    Toolbar Set ImageList hDlg, %IDC_ToolbarA, hLst, 0
    Toolbar Set ImageList hDlg, %IDC_ToolbarB, hLst, 0

    'create buttons
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 1, 201, %TbStyle_Check, "On/Off"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 2, 202, %TbStyle_Check, "x"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 3, 203, %TbStyle_Check, "y"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 4, 204, %TbStyle_Check, "z"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 26, 218, %TbStyle_Button, "Reset"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 27, 219, %TbStyle_Button, "Step"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 8, 205, %TbStyle_Check Or %TbStyle_Group, "Points"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 9, 206, %TbStyle_Check Or %TbStyle_Group, "Lines"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 10, 207, %TbStyle_Check Or %TbStyle_Group, "Surfaces"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20

    Toolbar Add Button    hDlg, %IDC_ToolbarA, 28, 220, %TbStyle_Check, "I/O"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 28, 220, %TbStyle_Check, "Wires"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 28, 220, %TbStyle_Check, "Lid"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 28, 220, %TbStyle_Check, "Explode"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 7, 208, %TbStyle_Check, "Cull"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 16, 209, %TbStyle_Check, "Sort"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 20, 222, %TbStyle_Check, "Project"
    Toolbar Add Separator hDlg, %IDC_ToolbarA, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 37, 230, %TbStyle_Check, "Data"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 43, 239, %TbStyle_Button, "Setup"
    Toolbar Add Button    hDlg, %IDC_ToolbarA, 33, 234, %TbStyle_Button, "Help"

    Toolbar Add Button    hDlg, %IDC_ToolbarB, 21, 215, %TbStyle_Check, "Gradient"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 22, 216, %TbStyle_Check, "Markers"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 36, 227, %TbStyle_Check, "No Line"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 23, 211, %TbStyle_DropDown, "Speed"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 13, 212, %TbStyle_DropDown, "Angle"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 24, 213, %TbStyle_DropDown, "Pt Size"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 18, 214, %TbStyle_DropDown, "Color"
    Toolbar Add Separator hDlg, %IDC_ToolbarB, 20
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 34, 225, %TbStyle_Button, "In"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 35, 226, %TbStyle_Button, "Out"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 38, 235, %TbStyle_Button, "Left"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 39, 236, %TbStyle_Button, "Right"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 40, 237, %TbStyle_Button, "Up"
    Toolbar Add Button    hDlg, %IDC_ToolbarB, 41, 238, %TbStyle_Button, "Down"

    Menu New PopUp To hPopup2
    Menu Add String, hPopup2, "1", 400, %MF_Enabled
    Menu Add String, hPopup2, "2", 401, %MF_Enabled
    Menu Add String, hPopup2, "5", 402, %MF_Enabled
    Menu Add String, hPopup2, "10", 403, %MF_Enabled
    Menu Add String, hPopup2, "20", 404, %MF_Enabled
    Menu Add String, hPopup2, "40", 405, %MF_Enabled
    Menu Add String, hPopup2, "60", 406, %MF_Enabled
    Menu Add String, hPopup2, "80", 407, %MF_Enabled
    Menu Add String, hPopup2, "100", 408, %MF_Enabled
    Menu Add String, hPopup2, "250", 409, %MF_Enabled
    Menu Add String, hPopup2, "500", 410, %MF_Enabled

    Menu New PopUp To hPopup3
    Menu Add String, hPopup3, "0.01", 420, %MF_Enabled
    Menu Add String, hPopup3, "0.02", 421, %MF_Enabled
    Menu Add String, hPopup3, "0.03", 422, %MF_Enabled
    Menu Add String, hPopup3, "0.04", 423, %MF_Enabled
    Menu Add String, hPopup3, "0.05", 424, %MF_Enabled
    Menu Add String, hPopup3, "0.10", 425, %MF_Enabled
    Menu Add String, hPopup3, "0.20", 426, %MF_Enabled

    Menu New PopUp To hPopup4
    Menu Add String, hPopup4, "1",  440, %MF_Enabled
    Menu Add String, hPopup4, "2",  441, %MF_Enabled
    Menu Add String, hPopup4, "3",  442, %MF_Enabled
    Menu Add String, hPopup4, "4",  443, %MF_Enabled
    Menu Add String, hPopup4, "5",  444, %MF_Enabled
    Menu Add String, hPopup4, "10", 445, %MF_Enabled
    Menu Add String, hPopup4, "25", 446, %MF_Enabled
    Menu Add String, hPopup4, "50", 447, %MF_Enabled

    Menu New PopUp To hPopup5
    Menu Add String, hPopup5, "Background ...",  460, %MF_Enabled
    Menu Add String, hPopup5, "Point ...",  461, %MF_Enabled
    Menu Add String, hPopup5, "Line ...",  462, %MF_Enabled
    Menu Add String, hPopup5, "Triangle ...",  463, %MF_Enabled

End Sub

Sub MakeTimer
   KillTimer hdlg, %IDC_Timer
   SetTimer(hDlg, %IDC_Timer, Speed, %NULL)    'sends %WM_Timer to dialog callback
End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult As Asciiz*%Max_Path, yResult As Asciiz*%Max_Path
   Local temp As Asciiz*%Max_Path, INIFileName As Asciiz*%Max_Path

   'defines file name (any file name will work)
   INIFileName = EXE.Path$ + "gbdesigner.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "850", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "700", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      Getprivateprofilestring "All", "RotateX", "1",       temp, %Max_Path, INIFileName   :   RotateX = Val(temp)
      Getprivateprofilestring "All", "RotateY", "1",       temp, %Max_Path, INIFileName   :   RotateY = Val(temp)
      Getprivateprofilestring "All", "RotateZ", "1",       temp, %Max_Path, INIFileName   :   RotateZ = Val(temp)
      Getprivateprofilestring "All", "PowerOn", "1",       temp, %Max_Path, INIFileName   :   PowerOn = Val(temp)
      Getprivateprofilestring "All", "Angle", "0.02",      temp, %Max_Path, INIFileName   :   Angle = Val(temp)
      Getprivateprofilestring "All", "DisplayType", "3",   temp, %Max_Path, INIFileName   :   DisplayType  = Val(temp)
      Getprivateprofilestring "All", "ModelType", "1",     temp, %Max_Path, INIFileName   :   ModelType  = Val(temp)
      Getprivateprofilestring "All", "DepthSort", "1",     temp, %Max_Path, INIFileName   :   DepthSort = Val(temp)
      Getprivateprofilestring "All", "BackFace", "1",      temp, %Max_Path, INIFileName   :   BackFace = Val(temp)
      Getprivateprofilestring "All", "Speed", "40",        temp, %Max_Path, INIFileName   :   Speed = Val(temp)
      Getprivateprofilestring "All", "Gradient", "0",      temp, %Max_Path, INIFileName   :   Gradient = Val(temp)
      Getprivateprofilestring "All", "BackColor", "0",     temp, %Max_Path, INIFileName  :    BackColor = Val(temp)
      Getprivateprofilestring "All", "LineColor", Str$(%Yellow),    temp, %Max_Path, INIFileName   :   LineColor = Val(temp)
      Getprivateprofilestring "All", "PointColor", Str$(%Red),      temp, %Max_Path, INIFileName   :   PointColor = Val(temp)
      Getprivateprofilestring "All", "TriangleColor", Str$(&H80),   temp, %Max_Path, INIFileName   :   TriangleColor = Val(temp)
      Getprivateprofilestring "All", "Markers", "0",                temp, %Max_Path, INIFileName   :   Markers = Val(temp)
      Getprivateprofilestring "All", "PointSize", "2",              temp, %Max_Path, INIFileName   :   PointSize = Val(temp)
      Getprivateprofilestring "All", "Projection", "0",             temp, %Max_Path, INIFileName   :   Projection = Val(temp)
      Getprivateprofilestring "All", "POV", "1000",                 temp, %Max_Path, INIFileName   :   POV = Val(temp)
      Getprivateprofilestring "All", "CurrentFileName", "",         temp, %Max_Path, INIFileName   :   CurrentFileName = temp
      Getprivateprofilestring "All", "NoLine", "0",                 temp, %Max_Path, INIFileName   :   NoLine = Val(temp)
      Getprivateprofilestring "All", "DataDisplay", "1",            temp, %Max_Path, INIFileName   :   DataDisplay = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Colors", "CustomColor" + Trim$(Str$(x)), "0",  temp, %Max_Path, INIFileName   :   CustomColorList.c(x) = Val(temp)
      Next x

      'apply as needed
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 201, %TBState_Checked * PowerOn Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 202, %TBState_Checked * RotateX Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 203, %TBState_Checked * RotateY Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 204, %TBState_Checked * RotateZ Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 204+DisplayType, %TBState_Checked Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 208, %TBState_Checked * BackFace Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 209, %TBState_Checked * DepthSort Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 222, %TBState_Checked * Projection Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarA, ByCmd 230, %TBState_Checked * DataDisplay Or %TBState_Enabled

      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 215, %TBState_Checked * Gradient Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 216, %TBState_Checked * Markers Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_ToolbarB, ByCmd 227, %TBState_Checked * NoLine Or %TBState_Enabled
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      temp = Str$(RotateX)      : WritePrivateProfileString "All", "RotateX", temp, INIFileName
      temp = Str$(RotateY)      : WritePrivateProfileString "All", "RotateY", temp, INIFileName
      temp = Str$(RotateZ)      : WritePrivateProfileString "All", "RotateZ", temp, INIFileName
      temp = Str$(PowerOn)      : WritePrivateProfileString "All", "PowerOn", temp, INIFileName
      temp = Str$(Angle)        : WritePrivateProfileString "All", "Angle", temp, INIFileName
      temp = Str$(DisplayType)  : WritePrivateProfileString "All", "DisplayType", temp, INIFileName
      temp = Str$(ModelType)    : WritePrivateProfileString "All", "ModelType", temp, INIFileName
      temp = Str$(DepthSort)    : WritePrivateProfileString "All", "DepthSort", temp, INIFileName
      temp = Str$(BackFace)     : WritePrivateProfileString "All", "BackFace", temp, INIFileName
      temp = Str$(Speed)        : WritePrivateProfileString "All", "Speed", temp, INIFileName
      temp = Str$(Gradient)     : WritePrivateProfileString "All", "Gradient", temp, INIFileName
      temp = Str$(BackColor)    : WritePrivateProfileString "All", "BackColor", temp, INIFileName
      temp = Str$(LineColor)    : WritePrivateProfileString "All", "LineColor", temp, INIFileName
      temp = Str$(PointColor)   : WritePrivateProfileString "All", "PointColor", temp, INIFileName
      temp = Str$(TriangleColor): WritePrivateProfileString "All", "TriangleColor", temp, INIFileName
      temp = Str$(Markers)      : WritePrivateProfileString "All", "Markers", temp, INIFileName
      temp = Str$(Pointsize)    : WritePrivateProfileString "All", "PointSize", temp, INIFileName
      temp = Str$(Projection)   : WritePrivateProfileString "All", "Projection", temp, INIFileName
      temp = Str$(POV)          : WritePrivateProfileString "All", "POV", temp, INIFileName
      temp = CurrentFileName    : WritePrivateProfileString "All", "CurrentFileName", temp, INIFileName
      temp = Str$(NoLine)       : WritePrivateProfileString "All", "NoLine", temp, INIFileName
      temp = Str$(DataDisplay)  : WritePrivateProfileString "All", "DataDisplay", temp, INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x)): WritePrivateProfileString "Colors", "CustomColor" + Trim$(Str$(x)), temp, INIFileName
      Next x

   End If
End Sub

Sub SetPointHighLow()
   Local i As Long
   If UBound(p) = -1 Then
       XHigh = 0: XLow = 0: YHigh = 0: YLow = 0: ZHigh = 0: ZLow = 0
   Else
       XHigh = P(1).xo: XLow = P(1).xo
       YHigh = P(1).yo: YLow = P(1).yo
       ZHigh = P(1).zo: ZLow = P(1).zo
       For i = 2 To UBound(P)
           If P(i).xo > XHigh Then XHigh = P(i).xo
           If P(i).xo < XLow Then XLow = P(i).xo

           If P(i).yo > YHigh Then YHigh = P(i).yo
           If P(i).yo < YLow Then YLow = P(i).yo

           If P(i).zo > ZHigh Then ZHigh = P(i).zo
           If P(i).zo < ZLow Then ZLow = P(i).zo
       Next i
   End If
End Sub

Sub SetTriangleHighLow()
   Local i As Long
   If UBound(T) < 1 Then
       THigh = 0: TLow = 0
   Else
       T(1).ZDepthO = (P(T(1).p1).Z + P(T(1).p2).Z + P(T(1).p3).Z) / 3
       THigh = T(1).ZDepthO : TLow = T(1).ZdepthO
       For i = 2 To UBound(T)
           T(i).ZDepthO = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
           If T(i).ZDepthO > THigh Then THigh = T(i).ZDepthO
           If T(i).ZDepthO < TLow Then TLow = T(i).ZDepthO
       Next i
   End If
End Sub

Sub ResetModel
   Local i As Long
   For i = 1 To UBound(P)
      P(i).x = P(i).xo : P(i).y = P(i).yo : P(i).z = P(i).zo
      POnly(i).x = P(i).xo : POnly(i).y = P(i).yo : POnly(i).z = P(i).zo
   Next i
End Sub

Sub ScaleToFit
   Local i,w,h As Long, sTemp As Single
   Local CenterX, CenterY, CenterZ, ScaleFactor As Single

   CenterX = (XHigh + XLow)/2
   CenterY = (YHigh + YLow)/2
   CenterZ = (ZHigh + ZLow)/2

   'move all nodes to center position
   For i = 1 To UBound(P)
      P(i).x = (P(i).xo - CenterX) : POnly(i).x = P(i).x
      P(i).y = (P(i).yo - CenterY) : POnly(i).y = P(i).y
      P(i).z = (P(i).zo - CenterZ) : POnly(i).z = P(i).z
   Next i

   'get farthest point to use for setting scalefactor
   FarthestPoint = 0
   For i = 1 To UBound(P)
      sTemp = Sqr(P(i).x*P(i).x + P(i).y*P(i).y + P(i).z*P(i).z)
      If FarthestPoint < Abs(sTemp) Then FarthestPoint = Abs(sTemp)
   Next i
   Control Get Size hDlg, %IDC_Graphic To w,h
   If h < w Then ScaleFactor = h /(2*FarthestPoint)*0.9 Else ScaleFactor = w/(2*FarthestPoint)*0.9

   'scale points to fit within graphic control
   For i = 1 To UBound(P)
      P(i).x = P(i).x * ScaleFactor : POnly(i).x = P(i).x
      P(i).y = P(i).y * ScaleFactor : POnly(i).y = P(i).y
      P(i).z = P(i).z * ScaleFactor : POnly(i).z = P(i).z
   Next i
End Sub

Function GetColor(startColor As Long) As Long
   Local ColorResult&
   Display Color hDlg, 100, 100, startColor, CustomColorList, 0 To ColorResult&
   If ColorResult& = -1 Then
      Function = startColor    'startColor is returned if Cancel/Escape is pressed
   Else
      Function = ColorResult&    'used SelectedColor& as firstcolor the next time the dialog is displayed
   End If
End Function

Sub DisplayInfo

    If DataDisplay = 0 Then Exit Sub

    Local temp As String
    temp =                "Model: " + PathName$(Namex,CurrentFileName)
    temp = temp + $CrLf + $CrLf + "Points: " + Str$(UBound(P))
    temp = temp + $CrLf + "Triangles: " + Str$(UBound(T))
    temp = temp + $CrLf
    temp = temp + $CrLf + "Display Mode: " + Choose$(DisplayType,"Point","Line","Surfaces")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Backface Cullt: " + IIf$(Backface,"On","Off")
    temp = temp + $CrLf + "Depth Sort: " + IIf$(DepthSort,"On","Off")
    temp = temp + $CrLf + "Projection: " + IIf$(Projection,"On","Off")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Gradient: " + IIf$(Gradient,"On","Off")
    temp = temp + $CrLf + "Markers: " + IIf$(Markers,"On","Off")

    temp = temp + $CrLf
    temp = temp + $CrLf + "Speed: " + Str$(Speed)
    temp = temp + $CrLf + "Angle: " + Str$(Angle)
    temp = temp + $CrLf + "Point Size: " + Str$(PointSize)

    Control Set Text hDlg, %IDC_TextBox, temp + $CrLf + $CrLf + OriginalPT
End Sub

Sub CreateOriginalPTString
    Local i As Long
    OriginalPT = "Points:"         'OriginalPT + $CrLf + $CrLf + "Points:"
    For i = 1 To UBound(P)
       OriginalPT = OriginalPT + $CrLf + Format$(P(i).x,"00") + Format$(P(i).y," 00") + Format$(P(i).z," 00")
    Next i
   OriginalPT = OriginalPT + $CrLf + $CrLf + "Triangles:"
    For i = 1 To UBound(T)
       OriginalPT = OriginalPT + $CrLf + Str$(T(i).p1) + Str$(T(i).p2) + Str$(T(i).p3)
    Next i
End Sub

Sub SetTriangleGradientColors
   Local i As Long
   If UBound(T) < 1 Then THigh = 0: TLow = 0 : Exit Sub
   SetTriangleHighLow
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ColorG = GradientZ(T(i).ZDepthO, THigh, TLow)
      Next i
   End If
End Sub

Sub SetPointGradientColors
   Local i As Long
   SetPointHighLow
   For i = 1 To UBound(P)
      P(i).ColorG = GradientZ(P(i).zo, ZHigh, ZLow) :  POnly(i).ColorG = P(i).ColorG
   Next i
End Sub

Function GradientZ(ZValue As Single, HiZ As Single, LoZ As Single) As Long
   'returns Long color, and RGB components, across the entire spectrum based on position of a number between two limits
   Local CRatio As Single, Exponent As Single
   Local R,G,B As Long
   Exponent = 0.365
   If HiZ <> LoZ Then
       CRatio = Abs((ZValue - LoZ) / (HiZ - LoZ))
   Else
       CRatio = 0
   End If

   If CRatio > 1 Then CRatio = 1
   If CRatio < 0 Then CRatio = 0

   Select Case CRatio
       Case Is < 0.25
           r = 0
           g = 255 * (((CRatio - 0) * 4) ^ Exponent)
           b = 255
       Case Is < 0.5
           r = 0
           g = 255
           b = 255 * ((1 - (CRatio - 0.25) * 4) ^ Exponent)
       Case Is < 0.75
           r = 255 * (((CRatio - 0.5) * 4) ^ Exponent)
           g = 255
           b = 0
       Case Else
           r = 255
           g = 255 * ((1 - (CRatio - 0.75) * 4) ^ Exponent)
           b = 0

   End Select
   Function = RGB(r, g, b)

End Function

Sub CycleSpeed
   Select Case Speed
      Case 1 : Speed = 2
      Case 2 : Speed = 5
      Case 5 : Speed = 10
      Case 10 : Speed = 20
      Case 20 : Speed = 40
      Case 40 : Speed = 60
      Case 60 : Speed = 80
      Case 80 : Speed = 100
      Case 100 : Speed = 250
      Case 250 : Speed = 500
      Case 500 : Speed = 1
   End Select
End Sub

Sub CyclePointSize
   Select Case Pointsize
      Case 1  : PointSize = 2
      Case 2  : PointSize = 3
      Case 3  : PointSize = 4
      Case 4  : PointSize = 5
      Case 5  : PointSize = 10
      Case 10 : PointSize = 25
      Case 25 : PointSize = 50
      Case 50 : PointSize = 1
   End Select
End Sub

Sub CycleModel
   Select Case ModelType
      Case 3
         If IsFile(CurrentFileName) Then
            ModelType = 4
            LoadSTLAFile CurrentFileName
         Else
            MsgBox "Bad file name!"
         End If
   End Select
End Sub

Sub CycleAngle
   Select Case Angle
      Case 0.01 : Angle = 0.02
      Case 0.02 : Angle = 0.03
      Case 0.03 : Angle = 0.04
      Case 0.04 : Angle = 0.05
      Case 0.05 : Angle = 0.10
      Case 0.10 : Angle = 0.20
      Case 0.20 : Angle = 0.01
   End Select
End Sub

Sub CycleColors
    Static ColorSelection As Long
    Select Case ColorSelection
       Case 0 : BColor = %rgb_Maroon
       Case 1 : BColor = %rgb_DarkGreen
       Case 2 : BColor = %rgb_DarkBlue
       Case 3 : BColor = %rgb_DimGray
       Case 4 : BColor = %Black
       Case 5 : BColor = %White
       Case 6 : BColor = BackColor
    End Select
    ColorSelection = ColorSelection + 1
    If ColorSelection > 6 Then Colorselection = 0
End Sub

Function SelectFileToOpen() As String
   Local filter$, startfile$, startfolder$
   Local defaultext$, flags&, filevar$, countvar&
   filter$ = Chr$("3D Files",0,"*.tov;*.stla;*.stlb",0)
'   filter$ = Chr$("TOV Files", 0, "*.tov", 0, "STL-Ascii", 0, "*.stla", 0, "STL-Binary", 0, "*.stlb", 0)
   startfolder$ = CurrentFileName     'initial folder to be displayed
   startfile$ = CurrentFileName       'name to be used as initial selection
   defaultext$ = "txt"                 'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, _
   defaultext$, flags& To filevar$, countvar&
   If IsFile(filevar$) Then Function = filevar$
End Function

Sub BuildLeftSide
   Local w,h As Long

   SendMessage(hDlg, %WM_SETREDRAW, 0, 0)  'Turn off redraw for faster and smoother action
   'start over - kill all controls
   Control Kill hDlg, 700            'progress bar
   Control Kill hDlg, %IDC_TextBox   'textbox

   If DataDisplay Then
      Dialog Get Client hDlg To w,h
      Control Add TextBox, hDlg, %IDC_TextBox, "", 210,90,175,h-120, TextBoxStyle
   End If

   SendMessage hDlg, %WM_SETREDRAW, 1, 0   'Turn on redraw again and refresh
   Dialog ReDraw hDlg

End Sub

Sub DisplayHelp
   Local temp As String
   temp = "Graphic Laboratory"
   temp = temp + $CrLf + "     Built-in cube and sphere models"
   temp = temp + $CrLf + "     TOV Files (point coordinates, triangle vertices)"
   temp = temp + $CrLf + "     Stereolithography (STL) Files (Ascii and Binary)"
   temp = temp + $CrLf + "     Equations of the form z = f(x,y)"

   temp = temp + $CrLf + $CrLf + "Display:"
   temp = temp + $CrLf + "     3D Pipeline: rotation, backface culling, depth sorting, and projection"
   temp = temp + $CrLf + "     Points, lines, and surfaces (T)"
   temp = temp + $CrLf + "     Rotate automatically, single-step or using mouse"
   temp = temp + $CrLf + "     XYZ rotation set independently"
   temp = temp + $CrLf + "     Reset, zoom and pan options"
   temp = temp + $CrLf + "     Control speed, rotation angle, point size, colors"
   temp = temp + $CrLf + "     Gradient colors based point/surface-center z-coordinates"

   temp = temp + $CrLf + $CrLf + "Built-In Models:"
   temp = temp + $CrLf + "     Cube and sphere models built-in"

   temp = temp + $CrLf + $CrLf + "Files:"
   temp = temp + $CrLf + "     Reads TOV/STLA/STLB file types"

   temp = temp + $CrLf + $CrLf + "Equations:"
   temp = temp + $CrLf + "     Dropdown equation list is read from 'equations.txt'"
   temp = temp + $CrLf + "     New/Delete/Modify/Save equation options are provided"
   temp = temp + $CrLf + "     New creates duplicate of current equation"
   temp = temp + $CrLf + "     Plot paramenters are: XMax, XMin, XStep and then YMax, YMin, YStep"
   temp = temp + $CrLf + $CrLf


   MsgBox temp, %MB_Ok, "gbMCM - MCM Concept Evaluator"
End Sub

Sub MoveUp
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y - 25 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveDown
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y + 25 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveLeft
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x - 25 : POnly(i).x = P(i).x
    Next i
End Sub

Sub MoveRight
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x + 25 : POnly(i).x = P(i).x
    Next i
End Sub

Sub ChangeSize (Flag As Long)
    Local i As Long, Factor As Single
    Factor = (1 + 0.2 * Flag)
    For i = 1 To UBound(P)
        P(i).x = P(i).x * Factor : POnly(i).x = P(i).x
        P(i).y = P(i).y * Factor : POnly(i).y = P(i).y
        P(i).z = P(i).z * Factor : POnly(i).z = P(i).z
    Next i
End Sub

Sub AddMenu()
   Menu New Bar To hMenu
   Menu New PopUp To hMenuFile
   Menu Add PopUp, hMenu, "&File", hMenuFile, %MF_Enabled
      Menu Add String, hMenuFile, "&Export As STL", %IDM_FileExportSTL, %MF_Enabled
'      Menu Add String, hMenuFile, "&Export As TOV", %IDM_FileExportTOV, %MF_Enabled
      Menu Add String, hMenuFile, "E&xit"         , %IDM_FileExit, %MF_Enabled
   Menu Attach hMenu, hDlg
End Sub

Sub AddDesignControls
    Dim AList() As String, Style1&, Style2&, i As Long
    Style1& = %CBS_DropDownList Or %WS_TabStop Or %WS_VScroll
    Style2& = %WS_Ex_Left Or %WS_Ex_ClientEdge

    Control Add Button, hDlg, 899, "Refresh", 130,100,55,20
    Control Add Label, hDlg, 900, "Parts List", 10,110,100,20
    Control Set Font hDlg, 900, hFontBold
    Control Add Label, hDlg, 901, "Memory ICs", 25,140,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 902, AList(),110,140,75,200, Style1&, Style2&
       ComboBox Select hDlg, 902, 13
    Control Add Label, hDlg, 903, "Resistors", 25,165,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 904, AList(),110,165,75,200, Style1&, Style2&
       ComboBox Select hDlg, 904, 13
    Control Add Label, hDlg, 905, "Processors", 25,190,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 906, AList(),110,190,75,200, Style1&, Style2&
       ComboBox Select hDlg, 906, 13
    Control Add Label, hDlg, 907, "Capacitors", 25,215,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 908, AList(),110,215,75,200, Style1&, Style2&
       ComboBox Select hDlg, 908, 13
    Control Add Label, hDlg, 909, "Custom ASIC", 25,240,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 910, AList(),110,240,75,200, Style1&, Style2&
       ComboBox Select hDlg, 910, 13
    Control Add Label, hDlg, 911, "Custom1 ", 25,265,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 912, AList(),110,265,75,200, Style1&, Style2&
       ComboBox Select hDlg, 912, 13
    Control Add Label, hDlg, 913, "Custom2", 25,290,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 914, AList(),110,290,75,200, Style1&, Style2&
       ComboBox Select hDlg, 914, 13
    Control Add Label, hDlg, 915, "Other", 25,315,100,20
       ReDim AList(13)
       Array Assign AList() = "20","15","10","9","8","7","6","5","4","3","2","1","0"
       Control Add ComboBox, hDlg, 916, AList(),110,315,75,200, Style1&, Style2&
       ComboBox Select hDlg, 916, 13

    Control Add Label, hDlg, 925, "Package Design", 10,355,100,18
    Control Set Font hDlg, 925, hFontBold
    Control Add Label, hDlg, 926, "External I/O", 25,385,70,18
    Control Add TextBox, hDlg, 927, "400", 110,385,70,18

    Control Add Label, hDlg, 928, "Interface", 25,410,70,18
    ReDim AList(2)
    Array Assign AList() = "Leaded","BGA","Perimeter"
    Control Add ComboBox, hDlg, 929, AList() , 110,410,70,100
    ComboBox Select hDlg, 929, 3

    Control Add Label, hDlg, 930, "Interconnect", 25,435,70,18
    ReDim AList(1)
    Array Assign AList() = "Drop-In","Integrated"
    Control Add ComboBox, hDlg, 931,AList(),110,435,70,100
    ComboBox Select hDlg, 931, 2

    Control Add Label, hDlg, 940, "Options", 10,475,100,20
    Control Set Font hDlg, 940, hFontBold

    Control Add Label, hDlg, 943, "Placement", 25,505,100,20
    ReDim AList(3)
    Array Assign AList() = "Std","Sorted","Random","Optimized"
    Control Add ComboBox, hDlg, 944, AList() , 110,505,70,100
    ComboBox Select hDlg, 944, 4

    Control Add Label, hDlg, 945, "Aspect Ratio", 25,530,100,20
    ReDim AList(10)
    Array Assign AList() = "1.0","1.2","1.4","1.6","1.8","2.0","2.2","2.4","2.6","2.8","3.0"
    Control Add ComboBox, hDlg, 946, AList(), 110,530,70,200
    ComboBox Select hDlg, 946, 11

    Control Add CheckBox, hDlg, 947, "Constrain Size", 25,555,150,20 , %BS_Left Or %BS_VCenter Or %WS_TabStop Or %BS_LeftText

    ReDim AList(18)
    Array Assign AList() = "901","903","905","907","909","911","913","915","926","928","930", _
                           "941","943","945","947","948","949","950","951"
    For i = 0 To UBound(AList)
       Control Set Font hDlg, Val(AList(i)), hFontBold2
    Next


End Sub


Sub DisplayDataDialog
  If hData Then Exit Sub
  Dialog New Pixels, 0, "MCM Design Parameters", 300,100,600,800, %WS_OverlappedWindow To hData
  wMax = 500 : hMax = 2300 : hs=5 : vs=5
  AddDataControls
  Dialog Show Modal hData, Call DataProc
End Sub

CallBack Function DataProc() As Long
  Select Case Cb.Msg
    Case %WM_InitDialog  : ScrollBarInitialize
    Case %WM_Size        : ScrollBarDisplay
    Case %WM_HScroll     : ScrollBarRespond %SB_Horz, Cb.WParam  'respond to horizontal scroll
    Case %WM_VScroll     : ScrollBarRespond %SB_Vert, Cb.WParam  'respond to vertical scroll
    Case %WM_MouseWheel
    Case %WM_Destroy     : hData = 0
  End Select
End Function

Sub ScrollBarInitialize
   Local si As ScrollInfo, wClient,hClient As Long
   Dialog Get Client hData To wClient, hClient                             'w/o scrollbars (called from WM_InitDialog)
   wClient -= GetSystemMetrics(%SM_CXVSCROLL)                             'less vertical scrollbar
   hClient -= GetSystemMetrics(%SM_CXHSCROLL)                             'less horizontal scrollbar
   si.cbSize=Len(si) : si.fMask=%SIF_All                                  'preset values before using SetScrollInfo
   si.nMax=hMax : si.nPage=hClient : SetScrollInfo hData, %SB_Vert, si, 1  'set Vert scrollbar properties
   si.nMax=wMax : si.nPage=wClient : SetScrollInfo hData, %SB_Horz, si, 1  'set Horz scrollbar properties
End Sub

Sub ScrollBarDisplay2
   Local si As ScrollInfo, wClient,hClient As Long
   Dialog Get Client hData To wClient, hClient                             'w/o scrollbars (called from WM_InitDialog)
   si.cbSize=Len(si) : si.fMask=%SIF_All                                  'preset values before using SetScrollInfo
   si.nMax=hMax : si.nPage=hClient : SetScrollInfo hData, %SB_Vert, si, 1  'set Vert scrollbar properties
   si.nMax=wMax : si.nPage=wClient : SetScrollInfo hData, %SB_Horz, si, 1  'set Horz scrollbar properties
End Sub

Sub ScrollBarDisplay
   Local wClient,hClient As Long
   Dialog Get Client hData To wClient, hClient
   ShowScrollBar hData, %SB_Horz, IsFalse((wClient+GetScrollPos(hData,%SB_Horz))>wMax) 'turn off if resize exceeds wMax
   ShowScrollBar hData, %SB_Vert, IsFalse((hClient+GetScrollPos(hData,%SB_Vert))>hMax) 'turn off if resize exceeps hMax
End Sub

Sub ScrollBarRespond(HorzVert As Long, wParam As Long)
   Local si As ScrollInfo, wClient, hClient, oldPos As Long
   si.cbSize=SizeOf(si) : si.fMask=%SIF_All
   GetScrollInfo hData, HorzVert, si
   oldPos=si.nPos
   Select Case Lo(Word, wParam)
      Case %SB_LineLeft, %SB_LineUp    :  si.nPos -= IIf(HorzVert,hs,vs)
      Case %SB_PageLeft, %SB_PageUp    :  si.nPos -= si.nPage
      Case %SB_LineRight, %SB_LineDown :  si.nPos += IIf(HorzVert,hs,vs)
      Case %SB_PageRight, %SB_PageDown :  si.nPos += si.nPage
      Case %SB_ThumbTrack              :  si.nPos=Hi(Word, wParam)
      Case Else                        :  Exit Sub
   End Select
   si.nPos=Max&(si.nMin, Min&(si.nPos, si.nMax-si.nPage))
   SetScrollInfo hData,HorzVert,si,1
   If HorzVert = %SB_Horz Then ScrollWindow hData, oldPos-si.nPos,0 , ByVal %NULL, ByVal %NULL  : Horz = si.nPos
   If HorzVert = %SB_Vert Then ScrollWindow hData, 0, oldPos-si.nPos, ByVal %NULL, ByVal %NULL : Vert = si.nPos
End Sub

Sub AddDataControls
 Local temp As String, i,j,iPos As Long

 Control Add Label,    hData, 1200, "********** Design Parameters **************************", 20,10,600,18
 Control Set Font hData, 1200, hFontBold

 Control Add Label,    hData, 1201, "Solder Balls", 20,40,100,3000
 Control Set Font hData, 1201, hFontBold
temp = "Pitch" + $CrLf + _                 '  1
 "Diameter" + $CrLf                        '  2
 Control Add Label,    hData, 1202, temp, 40,60,100,40
 Control Set Font hData, 1202, hFontNormal
 Control Add TextBox,  hData, 1001, "0.5", 240,60,50,18
 Control Add TextBox,  hData, 1002, "0.5", 240,80,50,18

 Control Add Label,    hData, 1203, "Perimeter Pads", 20,110,300,18
 Control Set Font hData, 1203, hFontBold
temp = "Pitch" + $CrLf + _                 '  3
 "Length" + $CrLf + _                      '  4
 "Width" + $CrLf + _                       '  5
 "Thickness" + $CrLf                       '  6
 Control Add Label,    hData, 1204, temp, 40,130,100,80
 Control Set Font hData, 1204, hFontNormal
 Control Add TextBox,  hData, 1003, "0.5", 240,130,50,18
 Control Add TextBox,  hData, 1004, "0.5", 240,150,50,18
 Control Add TextBox,  hData, 1005, "0.5", 240,170,50,18
 Control Add TextBox,  hData, 1006, "0.5", 240,190,50,18

 Control Add Label,    hData, 1205, "Leads", 20,220,100,100
 Control Set Font hData, 1205, hFontNormal
 Control Set Font hData, 1205, hFontBold
temp = "Pitch" + $CrLf + _                 '  7
 "Length" + $CrLf + _                      '  8
 "Width" + $CrLf + _                       '  9
 "Thickness" + $CrLf + _                   ' 10
 "Material" + $CrLf                        ' 11 ComboBox  Kovar, Copper
 Control Add Label,    hData, 1206, temp, 40,245,100,100
 Control Set Font hData, 1206, hFontNormal
 Control Add TextBox,  hData, 1007, "0.5", 240,240,50,18
 Control Add TextBox,  hData, 1008, "0.5", 240,260,50,18
 Control Add TextBox,  hData, 1009, "0.5", 240,280,50,18
 Control Add TextBox,  hData, 1010, "0.5", 240,300,50,18
 Control Add ComboBox, hData, 1011, , 240,320,50,100

 Control Add Label,    hData, 1207, "Interconnect", 20,360,300,18
 Control Set Font hData, 1207, hFontBold
temp = "Thickness" + $CrLf + _             ' 12
 "Wirebond pitch" + $CrLf + _              ' 13
 "Wirebond keepout" + $CrLf + _            ' 14
 "Assembly keepout" + $CrLf + _            ' 15
 "Bond pad keepout" + $CrLf + _            ' 16
 "Substrate thickness" + $CrLf + _         ' 17
 "Inerconnect Material" + $CrLf + _                    ' 18 ComboBox  Thick Film, Thin Film, Laminate, RDL
 "Substrate material" + $CrLf              ' 19 ComboBox  Silicon, Ceramic, Aluminum Nitride
 Control Add Label,    hData, 1208, temp, 40,385,200,160
 Control Set Font hData, 1208, hFontNormal
 Control Add TextBox,  hData, 1012, "0.5", 240,380,50,18
 Control Add TextBox,  hData, 1013, "0.5", 240,400,50,18
 Control Add TextBox,  hData, 1014, "0.5", 240,420,50,18
 Control Add TextBox,  hData, 1015, "0.5", 240,440,50,18
 Control Add TextBox,  hData, 1016, "0.5", 240,460,50,18
 Control Add TextBox,  hData, 1017, "0.5", 240,480,50,18
 Control Add ComboBox, hData, 1018, , 240,500,50,100
 Control Add ComboBox, hData, 1019, , 240,525,50,100

 Control Add Label,    hData, 1209, "Package", 20,550,300,18
 Control Set Font hData, 1209, hFontBold
temp = "Thickness" + $CrLf + _             ' 20
 "Dropin keepout" + $CrLf + _              ' 21
 "Wirebond ledge Width" + $CrLf + _        ' 22
 "Wirebond ledge height" + $CrLf + _       ' 23
 "Seal Ring Width" + $CrLf + _             ' 24
 "Seal Ring keepout" + $CrLf + _           ' 25
 "Lead ledge Width" + $CrLf + _            ' 26
 "Corner keepout" + $CrLf + _              ' 27
 "Seal Ring material" + $CrLf + _          ' 29 ComboBox  Kovar, Nickel, Aluminum, Plastic
 "Package material" + $CrLf                ' 30 ComboBox  Ceramic, Kovar, Laminate, RDL
 Control Add Label,    hData, 1210, temp, 40,575,200,220
 Control Set Font hData, 1210, hFontNormal
 Control Add TextBox,  hData, 1020, "0.5", 240,570,50,18
 Control Add TextBox,  hData, 1021, "0.5", 240,590,50,18
 Control Add TextBox,  hData, 1022, "0.5", 240,610,50,18
 Control Add TextBox,  hData, 1023, "0.5", 240,630,50,18
 Control Add TextBox,  hData, 1024, "0.5", 240,650,50,18
 Control Add TextBox,  hData, 1025, "0.5", 240,670,50,18
 Control Add TextBox,  hData, 1026, "0.5", 240,690,50,18
 Control Add TextBox,  hData, 1027, "0.5", 240,710,50,18
 '1028 removed
 Control Add ComboBox, hData, 1029, , 240,730,50,100
 Control Add ComboBox, hData, 1030, , 240,755,50,100

 Control Add Label,    hData, 1211, "Lid", 20,795,300,18
 Control Set Font hData, 1211, hFontBold
temp = "Thickness" + $CrLf + _             ' 31
 "Keepout" + $CrLf + _                     ' 32
 "Material" + $CrLf                        ' 33 ComboBox  Kovar, Aluminum, Plastic
 Control Add Label,    hData, 1212, temp, 40,820,100,80
 Control Set Font hData, 1212, hFontNormal
 Control Add TextBox,  hData, 1031, "0.5", 240,815,50,18
 Control Add TextBox,  hData, 1032, "0.5", 240,835,50,18
 Control Add ComboBox, hData, 1033, , 240,855,50,100

 Control Add Label,    hData, 1213, "Thermal Model", 20,895,300,18
 Control Set Font hData, 1213, hFontBold
temp =  "Part Attach thickness" + $CrLf + _  ' 34
 "Package Attach thickness" + $CrLf + _      ' 35
 "Substrate Attach thickness" + $CrLf + _    ' 36
 "Part Attach Material" + $CrLf + _          ' 37 ComboBox  Epoxy, Epoxy (Cond), Solder
 "Package Attach Material" + $CrLf + _        ' 39 ComboBox  Epoxy, Epoxy (Cond), Solder
 "Substrate Attach Material" + $CrLf         ' 38 ComboBox  Epoxy, Epoxy (Cond), Solder
 Control Add Label,    hData, 1214, temp, 40,920,200,140
 Control Set Font hData, 1214, hFontNormal
 Control Add TextBox,  hData, 1034, "0.5", 240,915,50,18
 Control Add TextBox,  hData, 1035, "0.5", 240,935,50,18
 Control Add TextBox,  hData, 1036, "0.5", 240,955,50,18
 Control Add ComboBox, hData, 1037, , 240,975,50,100
 Control Add ComboBox, hData, 1038, , 240,1000,50,100
 Control Add ComboBox, hData, 1039, , 240,1025,50,100

 Control Add Label, hData, 1215, "********** Component Part Data ******************************", 20,1070,600,18
 Control Set Font hData, 1215, hFontBold
 Control Add Label, hData, 1216, "Parameters         Power       I/O     Thermal Cond.   Density", 20,1100,600,18
 Control Set Font hData, 1216, hFontBold
temp = "Memory" + $CrLf + _              '  41  42  43  44
 "Processors" + $CrLf + _                '  45  46  47  48
 "Custom ASICs" + $CrLf + _              '  49  50  51  52
 "Control Logic" + $CrLf + _             '  53  54  55  56
 "Memory Cubes" + $CrLf + _              '  57  58  59  60
 "Resistors" + $CrLf + _                 '  61  62  63  64
 "Capacitors" + $CrLf + _                '  65  66  67  68
 "Other" + $CrLf                         '  69  70  71  72
 Control Add Label, hData, 1217, temp, 40,1120,150,160
 Control Set Font hData, 1217, hFontNormal
 j = 1
 For i = 1040 To 1071 Step 4
    Control Add TextBox, hData, i,   "0.5", 160, 1100+j*20,50,18
    Control Add TextBox, hData, i+1, "0.5", 230,1100+j*20,50,18
    Control Add TextBox, hData, i+2, "0.5", 320,1100+j*20,50,18
    Control Add TextBox, hData, i+3, "0.5", 420,1100+j*20,50,18
    Incr j
 Next i

 Control Add Label, hData, 1218, "Parameters         Width     Length     Thickness     Keepout", 20,1290,600,18
 Control Set Font hData, 1218, hFontBold
temp = "Memory" + $CrLf + _              '  72   73  74  75
 "Processors" + $CrLf + _                '  76   77  78  79
 "Custom ASICs" + $CrLf + _              '  80   81  82  83
 "Control Logic" + $CrLf + _             '  84   85  86  87
 "Memory Cubes" + $CrLf + _              '  88   89  90  91
 "Resistors" + $CrLf + _                 '  92   93  94  95
 "Capacitors" + $CrLf + _                '  96   97  98  99
 "Other" + $CrLf                         '  100 101 102 103
 Control Add Label, hData, 1219, temp, 40,1310,150,160
 Control Set Font hData, 1219, hFontNormal
 j = 1
 For i = 1072 To 1103 Step 4
    Control Add TextBox, hData, i,   "0.5", 160, 1290+j*20,50,18
    Control Add TextBox, hData, i+1, "0.5", 230,1290+j*20,50,18
    Control Add TextBox, hData, i+2, "0.5", 320,1290+j*20,50,18
    Control Add TextBox, hData, i+3, "0.5", 420,1290+j*20,50,18
    Incr j
 Next i


 Control Add Label, hData, 1220, "********** Material Part Data ***************************", 20,1520,600,18
 Control Set Font hData, 1220, hFontBold
 Control Add Label, hData, 1221, "Description          Thermal Cond          Density", 20,1560,500,18
 Control Set Font hData, 1221, hFontBold
temp = "Epoxy" + $CrLf + _                  '  104
 "Epoxy (conductive)" + $CrLf + _           '  105
 "Thick Film" + $CrLf + _                   '  106
 "Thin Film" + $CrLf + _                    '  107
 "Cofired Ceramic" + $CrLf + _              '  108
 "Laminate" + $CrLf + _                     '  109
 "RDL" + $CrLf + _                          '  110
 "Encapsulation" + $CrLf + _                '  111
 "Thermal spray" + $CrLf + _                '  112
 "Kovar" + $CrLf + _                        '  113
 "Aluminum" + $CrLf + _                     '  114
 "Aluminum nitride" + $CrLf + _             '  115
 "Copper" + $CrLf + _                       '  116
 "Plastic" + $CrLf + _                      '  117
 "Solder" + $CrLf + _                       '  118
 "Silicon"                                  '  119
 Control Add Label, hData, 1222, temp, 40,1585,175,350
 Control Set Font hData, 1222, hFontNormal
j = 1
 For i = 1104 To 1135 Step 2
    Control Add TextBox, hData, i,   "0.5", 200,1560+j*20,50,18
    Control Add TextBox, hData, i+1, "0.5", 330,1560+j*20,50,18
    Incr j
 Next i

End Sub

Sub CreateMCM
    Local NewCube As Cube
    RandomCube(NewCube)
    CreateCube(NewCube)
'    CaptureDesignInputs        'put user inputs into MCM variable
    CreatePartsList            'put parts list into MCM variable
    PositionParts_Std          '
    If ShowPackage       Then CreatePackage
    If ShowSubstrate     Then CreateSubstrate
    If ShowInterconnect  Then CreateInterconnect
    If ShowSealRing      Then CreateSealRing
    If ShowWireBondLedge Then CreateWireBondLedge
    If ShowParts         Then CreateParts
    If ShowWireBonds     Then CreateWireBonds
    If ShowLid           Then CreateLid
    If ShowSolderBalls   Then CreateSolderBalls    'BGA solderballs
    If ShowLeads         Then CreateLeads          'perimeter leads
    If ShowPads          Then CreatePads           'perimeter pads
End Sub

Sub UpdateMaterialLibrary      'do as user makes changes
End Sub

Sub UpdatePartList             'do as user makes changes
End Sub

Sub UpdateMCMDesignParameters  'do as user makes changes
End Sub

Sub RandomCube(C As Cube)
   Local j As Long
   Static k As Long
   j = Rnd(50,75)
   k = Rnd(-200,200)
   C.p1.x = -j+k  : C.P1.y = -j  : C.P1.z = -j
   C.p2.x = -j+k  : C.P2.y =  j  : C.P2.z = -j
   C.p3.x =  j+k  : C.P3.y =  j  : C.P3.z = -j
   C.p4.x =  j+k  : C.P4.y = -j  : C.P4.z = -j
   C.p5.x = -j+k  : C.P5.y = -j  : C.P5.z =  j
   C.p6.x = -j+k  : C.P6.y =  j  : C.P6.z =  j
   C.p7.x =  j+k  : C.P7.y =  j  : C.P7.z =  j
   C.p8.x =  j+k  : C.P8.y = -j  : C.P8.z =  j
End Sub

Sub CreateCube(C As Cube)
   Local i,j,k As Long
   j = UBound(P)
   ReDim Preserve P(j+8)
   ReDim Preserve POnly(j+8)
   P(j+1).x = C.P1.x  : P(j+1).y = C.P1.y  : P(j+1).z = C.P1.z
   P(j+2).x = C.P2.x  : P(j+2).y = C.P2.y  : P(j+2).z = C.P2.z
   P(j+3).x = C.P3.x  : P(j+3).y = C.P3.y  : P(j+3).z = C.P3.z
   P(j+4).x = C.P4.x  : P(j+4).y = C.P4.y  : P(j+4).z = C.P4.z
   P(j+5).x = C.P5.x  : P(j+5).y = C.P5.y  : P(j+5).z = C.P5.z
   P(j+6).x = C.P6.x  : P(j+6).y = C.P6.y  : P(j+6).z = C.P6.z
   P(j+7).x = C.P7.x  : P(j+7).y = C.P7.y  : P(j+7).z = C.P7.z
   P(j+8).x = C.P8.x  : P(j+8).y = C.P8.y  : P(j+8).z = C.P8.z

   k = UBound(T)
   ReDim Preserve T(k+12)
   T(k+1).p1 = j+1 : T(k+1).p2 = j+4 : T(k+1).p3 = j+3
   T(k+2).p1 = j+1 : T(k+2).p2 = j+3 : T(k+2).p3 = j+2
   T(k+3).p1 = j+5 : T(k+3).p2 = j+1 : T(k+3).p3 = j+2
   T(k+4).p1 = j+5 : T(k+4).p2 = j+2 : T(k+4).p3 = j+6
   T(k+5).p1 = j+8 : T(k+5).p2 = j+5 : T(k+5).p3 = j+6
   T(k+6).p1 = j+8 : T(k+6).p2 = j+6 : T(k+6).p3 = j+7
   T(k+7).p1 = j+4 : T(k+7).p2 = j+8 : T(k+7).p3 = j+7
   T(k+8).p1 = j+4 : T(k+8).p2 = j+7 : T(k+8).p3 = j+3
   T(k+9).p1 = j+3 : T(k+9).p2 = j+7 : T(k+9).p3 = j+6
   T(k+10).p1 = j+3 : T(k+10).p2 = j+6 : T(k+10).p3 = j+2
   T(k+11).p1 = j+4 : T(k+11).p2 = j+1 : T(k+11).p3 = j+5
   T(k+12).p1 = j+4 : T(k+12).p2 = j+5 : T(k+12).p3 = j+8

   For i = j To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
    Next i
   P(1).Marker = -1 : P(UBound(P)).Marker = 1
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Sub CreatePackage
End Sub

Sub CreateSubstrate
End Sub

Sub CreateInterconnect
End Sub

Sub CreateSealRing
End Sub

Sub CreateWireBondLedge
End Sub

Sub CreateParts
End Sub

Sub CreateWireBonds
End Sub

Sub CreateLid
End Sub

Sub CreateSolderBalls    'BGA solderballs
End Sub

Sub CreateLeads          'perimeter leads
End Sub

Sub CreatePads           'perimeter pads
End Sub

Sub CreatePartsList
End Sub

Sub PositionParts_Std
   'left to right, then down when xMax is exceeded. as the parts are found in the list
   Local i,x,y,xk,yk,xedge,yedge,xcenter,ycenter,xdelta,ydelta As Long
   Local xRequired,yRequired,xMax,yMax As Long
   xrequired = 0 : yrequired = 0 : For i = 1 To UBound(PL) : PL(i).placed = 0 : Next i  'initialize
   For i = 1 To UBound(PL)
      If PL(i).placed = 1 Then Iterate For Else PL(i).placed = 1
      x = PL(i).x + 2*PL(i).xk : y = PL(i).y + 2*PL(i).yk  'convenience variables, used in this function
      Select Case (xedge+x)
          Case < xMax     'keep moving right
             xRequired = Max (xedge+x,xRequired)
             PL(i).xcenter = xedge + x/2 : PL(i).ycenter = yedge + y/2
             If ydelta < y Then ydelta = y
             xedge = xedge + x
          Case = xMax     'draw here, then next part at left
             xRequired = Max (xMax,xRequired)
             PL(i).xcenter = xedge + x/2 : PL(i).ycenter = yedge + y/2
             If ydelta < y Then ydelta = y
             yedge = yedge + ydelta
             ydelta = 0
             xedge = 0
          Case > xMax     'draw this part at left
             xRequired = Max (xedge,xRequired)
'             If GapFiller Then FillGap i,xedge,yedge,ydelta
             yedge = yedge + ydelta
             PL(i).xcenter = x/2 : PL(i).ycenter = yedge + y/2
             ydelta = y
             xedge = x
      End Select
      yRequired = yedge + ydelta
   Next i
End Sub
